webpackJsonp([12],{

/***/ 101:
/***/ (function(module, exports) {


/**
 * When source maps are enabled, `style-loader` uses a link element with a data-uri to
 * embed the css on the page. This breaks all relative urls because now they are relative to a
 * bundle instead of the current page.
 *
 * One solution is to only use full urls, but that may be impossible.
 *
 * Instead, this function "fixes" the relative urls to be absolute according to the current page location.
 *
 * A rudimentary test suite is located at `test/fixUrls.js` and can be run via the `npm test` command.
 *
 */

module.exports = function (css) {
  // get current location
  var location = typeof window !== "undefined" && window.location;

  if (!location) {
    throw new Error("fixUrls requires window.location");
  }

	// blank or null?
	if (!css || typeof css !== "string") {
	  return css;
  }

  var baseUrl = location.protocol + "//" + location.host;
  var currentDir = baseUrl + location.pathname.replace(/\/[^\/]*$/, "/");

	// convert each url(...)
	/*
	This regular expression is just a way to recursively match brackets within
	a string.

	 /url\s*\(  = Match on the word "url" with any whitespace after it and then a parens
	   (  = Start a capturing group
	     (?:  = Start a non-capturing group
	         [^)(]  = Match anything that isn't a parentheses
	         |  = OR
	         \(  = Match a start parentheses
	             (?:  = Start another non-capturing groups
	                 [^)(]+  = Match anything that isn't a parentheses
	                 |  = OR
	                 \(  = Match a start parentheses
	                     [^)(]*  = Match anything that isn't a parentheses
	                 \)  = Match a end parentheses
	             )  = End Group
              *\) = Match anything and then a close parens
          )  = Close non-capturing group
          *  = Match anything
       )  = Close capturing group
	 \)  = Match a close parens

	 /gi  = Get all matches, not the first.  Be case insensitive.
	 */
	var fixedCss = css.replace(/url\s*\(((?:[^)(]|\((?:[^)(]+|\([^)(]*\))*\))*)\)/gi, function(fullMatch, origUrl) {
		// strip quotes (if they exist)
		var unquotedOrigUrl = origUrl
			.trim()
			.replace(/^"(.*)"$/, function(o, $1){ return $1; })
			.replace(/^'(.*)'$/, function(o, $1){ return $1; });

		// already a full url? no change
		if (/^(#|data:|http:\/\/|https:\/\/|file:\/\/\/)/i.test(unquotedOrigUrl)) {
		  return fullMatch;
		}

		// convert the url to a full url
		var newUrl;

		if (unquotedOrigUrl.indexOf("//") === 0) {
		  	//TODO: should we add protocol?
			newUrl = unquotedOrigUrl;
		} else if (unquotedOrigUrl.indexOf("/") === 0) {
			// path should be relative to the base url
			newUrl = baseUrl + unquotedOrigUrl; // already starts with '/'
		} else {
			// path should be relative to current directory
			newUrl = currentDir + unquotedOrigUrl.replace(/^\.\//, ""); // Strip leading './'
		}

		// send back the fixed url(...)
		return "url(" + JSON.stringify(newUrl) + ")";
	});

	// send back the fixed css
	return fixedCss;
};


/***/ }),

/***/ 20:
/***/ (function(module, exports) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/
// css base code, injected by the css-loader
module.exports = function(useSourceMap) {
	var list = [];

	// return the list of modules as css string
	list.toString = function toString() {
		return this.map(function (item) {
			var content = cssWithMappingToString(item, useSourceMap);
			if(item[2]) {
				return "@media " + item[2] + "{" + content + "}";
			} else {
				return content;
			}
		}).join("");
	};

	// import a list of modules into the list
	list.i = function(modules, mediaQuery) {
		if(typeof modules === "string")
			modules = [[null, modules, ""]];
		var alreadyImportedModules = {};
		for(var i = 0; i < this.length; i++) {
			var id = this[i][0];
			if(typeof id === "number")
				alreadyImportedModules[id] = true;
		}
		for(i = 0; i < modules.length; i++) {
			var item = modules[i];
			// skip already imported module
			// this implementation is not 100% perfect for weird media query combinations
			//  when a module is imported multiple times with different media queries.
			//  I hope this will never occur (Hey this way we have smaller bundles)
			if(typeof item[0] !== "number" || !alreadyImportedModules[item[0]]) {
				if(mediaQuery && !item[2]) {
					item[2] = mediaQuery;
				} else if(mediaQuery) {
					item[2] = "(" + item[2] + ") and (" + mediaQuery + ")";
				}
				list.push(item);
			}
		}
	};
	return list;
};

function cssWithMappingToString(item, useSourceMap) {
	var content = item[1] || '';
	var cssMapping = item[3];
	if (!cssMapping) {
		return content;
	}

	if (useSourceMap && typeof btoa === 'function') {
		var sourceMapping = toComment(cssMapping);
		var sourceURLs = cssMapping.sources.map(function (source) {
			return '/*# sourceURL=' + cssMapping.sourceRoot + source + ' */'
		});

		return [content].concat(sourceURLs).concat([sourceMapping]).join('\n');
	}

	return [content].join('\n');
}

// Adapted from convert-source-map (MIT)
function toComment(sourceMap) {
	// eslint-disable-next-line no-undef
	var base64 = btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap))));
	var data = 'sourceMappingURL=data:application/json;charset=utf-8;base64,' + base64;

	return '/*# ' + data + ' */';
}


/***/ }),

/***/ 260:
/***/ (function(module, exports, __webpack_require__) {

__webpack_require__(771);
__webpack_require__(772);
__webpack_require__(773);
__webpack_require__(774);
__webpack_require__(775);
__webpack_require__(776);
__webpack_require__(777);
__webpack_require__(778);
__webpack_require__(779);
__webpack_require__(781);
__webpack_require__(782);
__webpack_require__(783);


/***/ }),

/***/ 362:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 *
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Cornelius Weiß <c.weiss@metaways.de>
 * @copyright   Copyright (c) 2017 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.ns('Tine.MailFiler.nodeActions');

/**
 * @singleton
 */
Tine.MailFiler.nodeActionsMgr = new (Ext.extend(Tine.widgets.ActionManager, {
    actionConfigs: Tine.MailFiler.nodeActions
}))();

// TODO: add more actions
// TODO: extend Filemanager.nodeActions

/**
 * create new folder, needs a single folder selection with addGrant
 */
Tine.MailFiler.nodeActions.CreateFolder = {
    app: 'MailFiler',
    requiredGrant: 'addGrant',
    allowMultiple: false,
    // actionType: 'add',
    text: 'Create Folder', // _('Create Folder')
    disabled: true,
    iconCls: 'action_create_folder',
    scope: this,
    handler: function() {
        var app = this.initialConfig.app,
            currentFolderNode = this.initialConfig.selections[0],
            nodeName = Tine.MailFiler.Model.Node.getContainerName();

        Ext.MessageBox.prompt(app.i18n._('New Folder'), app.i18n._('Please enter the name of the new folder:'), function(btn, text) {
            if(currentFolderNode && btn == 'ok') {
                if (! text) {
                    Ext.Msg.alert(String.format(app.i18n._('No {0} added'), nodeName), String.format(app.i18n._('You have to supply a {0} name!'), nodeName));
                    return;
                }

                var filename = currentFolderNode.get('path') + '/' + text;
                Tine.MailFiler.fileRecordBackend.createFolder(filename);
            }
        }, this);
    },
    actionUpdater: function(action, grants, records, isFilterSelect) {
        var enabled = !isFilterSelect
            && records && records.length == 1
            && records[0].get('type') == 'folder'
            && window.lodash.get(records, '[0].data.account_grants.addGrant', false);

        action.setDisabled(!enabled);
    }
};

/**
 * show native file select, upload files, create nodes
 * a single directory node with create grant has to be selected
 * for this action to be active
 */
// Tine.MailFiler.nodeActions.UploadFiles = {};

/**
 * single file or directory node with readGrant
 */
Tine.MailFiler.nodeActions.Edit = {
    app: 'MailFiler',
    requiredGrant: 'readGrant',
    allowMultiple: false,
    text: 'Edit Properties', // _('Edit Properties')
    iconCls: 'action_edit_file',
    disabled: true,
    // actionType: 'edit',
    scope: this,
    handler: function () {
        if(this.initialConfig.selections.length == 1) {
            Tine.MailFiler.NodeEditDialog.openWindow({record: this.initialConfig.selections[0]});
        }
    },
    actionUpdater: function(action, grants, records, isFilterSelect) {
        // run default updater
        Tine.widgets.ActionUpdater.prototype.defaultUpdater(action, grants, records, isFilterSelect);

        var _ = window.lodash,
            disabled = _.isFunction(action.isDisabled) ? action.isDisabled() : action.disabled;

        // if enabled check for not accessible node and disable
        if (! disabled) {
            action.setDisabled(window.lodash.reduce(records, function(disabled, record) {
                return disabled || record.isVirtual();
            }, false));
        }
    }
};

/**
 * single file or directory node with editGrant
 */
Tine.MailFiler.nodeActions.Rename = {
    app: 'MailFiler',
    requiredGrant: 'editGrant',
    allowMultiple: false,
    text: 'Rename', // _('Rename')
    iconCls: 'action_rename',
    disabled: true,
    // actionType: 'edit',
    scope: this,
    handler: function () {
        var _ = window.lodash,
            app = this.initialConfig.app,
            record = this.initialConfig.selections[0],
            nodeName = record.get('type') == 'folder' ?
                Tine.MailFiler.Model.Node.getContainerName() :
                Tine.MailFiler.Model.Node.getRecordName();

        Ext.MessageBox.show({
            title: String.format(i18n._('Rename {0}'), nodeName),
            msg: String.format(i18n._('Please enter the new name of the {0}:'), nodeName),
            buttons: Ext.MessageBox.OKCANCEL,
            value: record.get('name'),
            fn: function (btn, text) {
                if (btn == 'ok') {
                    if (!text) {
                        Ext.Msg.alert(String.format(i18n._('Not renamed {0}'), nodeName), String.format(i18n._('You have to supply a {0} name!'), nodeName));
                        return;
                    }

                    // @TODO validate filename
                    var targetPath = record.get('path').replace(_.escapeRegExp(new RegExp(record.get('name')) +'$'), text);
                    Tine.MailFiler.fileRecordBackend.copyNodes([record], targetPath, true);

                }
            },
            scope: this,
            prompt: true,
            icon: Ext.MessageBox.QUESTION
        });
    }
};

/**
 * one or multiple nodes, all need deleteGrant
 */
Tine.MailFiler.nodeActions.Delete = {
    app: 'MailFiler',
    requiredGrant: 'deleteGrant',
    allowMultiple: true,
    text: 'Delete', // _('Delete')
    disabled: true,
    iconCls: 'action_delete',
    scope: this,
    handler: function (button, event) {
        var app = this.initialConfig.app,
            nodeName = '',
            nodes = this.initialConfig.selections;

        if (nodes && nodes.length) {
            for (var i = 0; i < nodes.length; i++) {
                var currNodeData = nodes[i].data;

                if (typeof currNodeData.name == 'object') {
                    nodeName += currNodeData.name.name + '<br />';
                }
                else {
                    nodeName += currNodeData.name + '<br />';
                }
            }
        }

        this.conflictConfirmWin = Tine.widgets.dialog.FileListDialog.openWindow({
            modal: true,
            allowCancel: false,
            height: 180,
            width: 300,
            title: app.i18n._('Do you really want to delete the following files?'),
            text: nodeName,
            scope: this,
            handler: function (button) {
                if (nodes && button == 'yes') {
                    Tine.MailFiler.fileRecordBackend.deleteItems(nodes);
                }

                for (var i = 0; i < nodes.length; i++) {
                    var node = nodes[i];

                    if (node.fileRecord) {
                        var upload = Tine.Tinebase.uploadManager.getUpload(node.fileRecord.get('uploadKey'));
                        upload.setPaused(true);
                        Tine.Tinebase.uploadManager.unregisterUpload(upload.id);
                    }

                }
            }
        });
    }
};

/**
 * one node with readGrant
 */
// Tine.MailFiler.nodeActions.Copy = {};

/**
 * one or multiple nodes with read, edit AND deleteGrant
 */
Tine.MailFiler.nodeActions.Move = {
    app: 'MailFiler',
    requiredGrant: 'editGrant',
    allowMultiple: true,
    text: 'Move', // _('Move')
    disabled: true,
    actionType: 'edit',
    scope: this,
    iconCls: 'action_move',
    handler: function() {
        var app = this.initialConfig.app,
            i18n = app.i18n,
            records = this.initialConfig.selections;

        var filePickerDialog = new Tine.MailFiler.FilePickerDialog({
            title: app.i18n._('Move Items'),
            singleSelect: true,
            constraint: 'folder'
        });

        filePickerDialog.on('selected', function(nodes) {
            var node = nodes[0];
            Tine.MailFiler.fileRecordBackend.copyNodes(records, node.path, true);
        });

        filePickerDialog.openWindow();
    },
};

/**
 * one file node with download grant
 */
Tine.MailFiler.nodeActions.Download = {
    app: 'MailFiler',
    requiredGrant: 'downloadGrant',
    allowMultiple: false,
    actionType: 'download',
    text: 'Save locally', // _('Save locally')
    iconCls: 'action_filemanager_save_all',
    disabled: true,
    scope: this,
    handler: function() {
        Tine.Filemanager.downloadFile(this.initialConfig.selections[0], null, 'MailFiler');
    },
    actionUpdater: function(action, grants, records, isFilterSelect) {
        var enabled = !isFilterSelect
            && records && records.length == 1
            && records[0].get('type') != 'folder'
            && window.lodash.get(records, '[0].data.account_grants.downloadGrant', false);

        action.setDisabled(!enabled);
    }
};

///**
// * one file node with readGrant
// */
//Tine.MailFiler.nodeActions.Preview = {
//    app: 'MailFiler',
//    allowMultiple: false,
//    requiredGrant: 'readGrant',
//    text: 'Preview', // _('Preview')
//    disabled: true,
//    iconCls: 'action_preview',
//    scope: this,
//    handler: function () {
//        var selections = this.initialConfig.selections;
//
//        if (selections.length > 0) {
//            var selection = selections[0];
//
//            if (selection && selection.get('type') === 'file') {
//                Tine.MailFiler.DocumentPreview.openWindow({
//                    record: selection
//                });
//            }
//        }
//    }
//};
//


/***/ }),

/***/ 68:
/***/ (function(module, exports, __webpack_require__) {

/*
	MIT License http://www.opensource.org/licenses/mit-license.php
	Author Tobias Koppers @sokra
*/

var stylesInDom = {};

var	memoize = function (fn) {
	var memo;

	return function () {
		if (typeof memo === "undefined") memo = fn.apply(this, arguments);
		return memo;
	};
};

var isOldIE = memoize(function () {
	// Test for IE <= 9 as proposed by Browserhacks
	// @see http://browserhacks.com/#hack-e71d8692f65334173fee715c222cb805
	// Tests for existence of standard globals is to allow style-loader
	// to operate correctly into non-standard environments
	// @see https://github.com/webpack-contrib/style-loader/issues/177
	return window && document && document.all && !window.atob;
});

var getElement = (function (fn) {
	var memo = {};

	return function(selector) {
		if (typeof memo[selector] === "undefined") {
			var styleTarget = fn.call(this, selector);
			// Special case to return head of iframe instead of iframe itself
			if (styleTarget instanceof window.HTMLIFrameElement) {
				try {
					// This will throw an exception if access to iframe is blocked
					// due to cross-origin restrictions
					styleTarget = styleTarget.contentDocument.head;
				} catch(e) {
					styleTarget = null;
				}
			}
			memo[selector] = styleTarget;
		}
		return memo[selector]
	};
})(function (target) {
	return document.querySelector(target)
});

var singleton = null;
var	singletonCounter = 0;
var	stylesInsertedAtTop = [];

var	fixUrls = __webpack_require__(101);

module.exports = function(list, options) {
	if (typeof DEBUG !== "undefined" && DEBUG) {
		if (typeof document !== "object") throw new Error("The style-loader cannot be used in a non-browser environment");
	}

	options = options || {};

	options.attrs = typeof options.attrs === "object" ? options.attrs : {};

	// Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
	// tags it will allow on a page
	if (!options.singleton) options.singleton = isOldIE();

	// By default, add <style> tags to the <head> element
	if (!options.insertInto) options.insertInto = "head";

	// By default, add <style> tags to the bottom of the target
	if (!options.insertAt) options.insertAt = "bottom";

	var styles = listToStyles(list, options);

	addStylesToDom(styles, options);

	return function update (newList) {
		var mayRemove = [];

		for (var i = 0; i < styles.length; i++) {
			var item = styles[i];
			var domStyle = stylesInDom[item.id];

			domStyle.refs--;
			mayRemove.push(domStyle);
		}

		if(newList) {
			var newStyles = listToStyles(newList, options);
			addStylesToDom(newStyles, options);
		}

		for (var i = 0; i < mayRemove.length; i++) {
			var domStyle = mayRemove[i];

			if(domStyle.refs === 0) {
				for (var j = 0; j < domStyle.parts.length; j++) domStyle.parts[j]();

				delete stylesInDom[domStyle.id];
			}
		}
	};
};

function addStylesToDom (styles, options) {
	for (var i = 0; i < styles.length; i++) {
		var item = styles[i];
		var domStyle = stylesInDom[item.id];

		if(domStyle) {
			domStyle.refs++;

			for(var j = 0; j < domStyle.parts.length; j++) {
				domStyle.parts[j](item.parts[j]);
			}

			for(; j < item.parts.length; j++) {
				domStyle.parts.push(addStyle(item.parts[j], options));
			}
		} else {
			var parts = [];

			for(var j = 0; j < item.parts.length; j++) {
				parts.push(addStyle(item.parts[j], options));
			}

			stylesInDom[item.id] = {id: item.id, refs: 1, parts: parts};
		}
	}
}

function listToStyles (list, options) {
	var styles = [];
	var newStyles = {};

	for (var i = 0; i < list.length; i++) {
		var item = list[i];
		var id = options.base ? item[0] + options.base : item[0];
		var css = item[1];
		var media = item[2];
		var sourceMap = item[3];
		var part = {css: css, media: media, sourceMap: sourceMap};

		if(!newStyles[id]) styles.push(newStyles[id] = {id: id, parts: [part]});
		else newStyles[id].parts.push(part);
	}

	return styles;
}

function insertStyleElement (options, style) {
	var target = getElement(options.insertInto)

	if (!target) {
		throw new Error("Couldn't find a style target. This probably means that the value for the 'insertInto' parameter is invalid.");
	}

	var lastStyleElementInsertedAtTop = stylesInsertedAtTop[stylesInsertedAtTop.length - 1];

	if (options.insertAt === "top") {
		if (!lastStyleElementInsertedAtTop) {
			target.insertBefore(style, target.firstChild);
		} else if (lastStyleElementInsertedAtTop.nextSibling) {
			target.insertBefore(style, lastStyleElementInsertedAtTop.nextSibling);
		} else {
			target.appendChild(style);
		}
		stylesInsertedAtTop.push(style);
	} else if (options.insertAt === "bottom") {
		target.appendChild(style);
	} else if (typeof options.insertAt === "object" && options.insertAt.before) {
		var nextSibling = getElement(options.insertInto + " " + options.insertAt.before);
		target.insertBefore(style, nextSibling);
	} else {
		throw new Error("[Style Loader]\n\n Invalid value for parameter 'insertAt' ('options.insertAt') found.\n Must be 'top', 'bottom', or Object.\n (https://github.com/webpack-contrib/style-loader#insertat)\n");
	}
}

function removeStyleElement (style) {
	if (style.parentNode === null) return false;
	style.parentNode.removeChild(style);

	var idx = stylesInsertedAtTop.indexOf(style);
	if(idx >= 0) {
		stylesInsertedAtTop.splice(idx, 1);
	}
}

function createStyleElement (options) {
	var style = document.createElement("style");

	options.attrs.type = "text/css";

	addAttrs(style, options.attrs);
	insertStyleElement(options, style);

	return style;
}

function createLinkElement (options) {
	var link = document.createElement("link");

	options.attrs.type = "text/css";
	options.attrs.rel = "stylesheet";

	addAttrs(link, options.attrs);
	insertStyleElement(options, link);

	return link;
}

function addAttrs (el, attrs) {
	Object.keys(attrs).forEach(function (key) {
		el.setAttribute(key, attrs[key]);
	});
}

function addStyle (obj, options) {
	var style, update, remove, result;

	// If a transform function was defined, run it on the css
	if (options.transform && obj.css) {
	    result = options.transform(obj.css);

	    if (result) {
	    	// If transform returns a value, use that instead of the original css.
	    	// This allows running runtime transformations on the css.
	    	obj.css = result;
	    } else {
	    	// If the transform function returns a falsy value, don't add this css.
	    	// This allows conditional loading of css
	    	return function() {
	    		// noop
	    	};
	    }
	}

	if (options.singleton) {
		var styleIndex = singletonCounter++;

		style = singleton || (singleton = createStyleElement(options));

		update = applyToSingletonTag.bind(null, style, styleIndex, false);
		remove = applyToSingletonTag.bind(null, style, styleIndex, true);

	} else if (
		obj.sourceMap &&
		typeof URL === "function" &&
		typeof URL.createObjectURL === "function" &&
		typeof URL.revokeObjectURL === "function" &&
		typeof Blob === "function" &&
		typeof btoa === "function"
	) {
		style = createLinkElement(options);
		update = updateLink.bind(null, style, options);
		remove = function () {
			removeStyleElement(style);

			if(style.href) URL.revokeObjectURL(style.href);
		};
	} else {
		style = createStyleElement(options);
		update = applyToTag.bind(null, style);
		remove = function () {
			removeStyleElement(style);
		};
	}

	update(obj);

	return function updateStyle (newObj) {
		if (newObj) {
			if (
				newObj.css === obj.css &&
				newObj.media === obj.media &&
				newObj.sourceMap === obj.sourceMap
			) {
				return;
			}

			update(obj = newObj);
		} else {
			remove();
		}
	};
}

var replaceText = (function () {
	var textStore = [];

	return function (index, replacement) {
		textStore[index] = replacement;

		return textStore.filter(Boolean).join('\n');
	};
})();

function applyToSingletonTag (style, index, remove, obj) {
	var css = remove ? "" : obj.css;

	if (style.styleSheet) {
		style.styleSheet.cssText = replaceText(index, css);
	} else {
		var cssNode = document.createTextNode(css);
		var childNodes = style.childNodes;

		if (childNodes[index]) style.removeChild(childNodes[index]);

		if (childNodes.length) {
			style.insertBefore(cssNode, childNodes[index]);
		} else {
			style.appendChild(cssNode);
		}
	}
}

function applyToTag (style, obj) {
	var css = obj.css;
	var media = obj.media;

	if(media) {
		style.setAttribute("media", media)
	}

	if(style.styleSheet) {
		style.styleSheet.cssText = css;
	} else {
		while(style.firstChild) {
			style.removeChild(style.firstChild);
		}

		style.appendChild(document.createTextNode(css));
	}
}

function updateLink (link, options, obj) {
	var css = obj.css;
	var sourceMap = obj.sourceMap;

	/*
		If convertToAbsoluteUrls isn't defined, but sourcemaps are enabled
		and there is no publicPath defined then lets turn convertToAbsoluteUrls
		on by default.  Otherwise default to the convertToAbsoluteUrls option
		directly
	*/
	var autoFixUrls = options.convertToAbsoluteUrls === undefined && sourceMap;

	if (options.convertToAbsoluteUrls || autoFixUrls) {
		css = fixUrls(css);
	}

	if (sourceMap) {
		// http://stackoverflow.com/a/26603875
		css += "\n/*# sourceMappingURL=data:application/json;base64," + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + " */";
	}

	var blob = new Blob([css], { type: "text/css" });

	var oldSrc = link.href;

	link.href = URL.createObjectURL(blob);

	if(oldSrc) URL.revokeObjectURL(oldSrc);
}


/***/ }),

/***/ 771:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Alexander Stintzing <a.stintzing@metaways.de>
 * @copyright   Copyright (c) 2007-2014 Metaways Infosystems GmbH (http://www.metaways.de)
 */

Ext.ns('Tine.MailFiler');

/**
 * generic exception handler for filemanager
 * 
 * @namespace Tine.MailFiler
 * @param {Tine.Exception} exception
 * @param {Object} request
 */
Tine.MailFiler.handleRequestException = function(exception, request) {

    var app = Tine.Tinebase.appMgr.get('MailFiler'),
        existingFilenames = [],
        nonExistantFilenames = [],
        i,
        filenameWithoutPath = null;

    switch(exception.code) {
        // overwrite default 503 handling and add a link to the wiki
        case 503:
            Ext.MessageBox.show({
                buttons: Ext.Msg.OK,
                icon: Ext.MessageBox.WARNING,
                title: i18n._('Service Unavailable'),
                msg: String.format(app.i18n._('The MailFiler is not configured correctly. Please refer to the {0}Tine 2.0 Admin FAQ{1} for configuration advice or contact your administrator.'),
                    '<a href="http://wiki.tine20.org/Admin_FAQ#The_message_.22filesdir_config_value_not_set.22_appears_in_the_logfile_and_I_can.27t_open_the_MailFiler" target="_blank">',
                    '</a>')
            });
            break;

        case 901:
            if (request) {
                Tine.log.debug('Tine.MailFiler.handleRequestException - request exception:');
                Tine.log.debug(exception);

                if (exception.existingnodesinfo) {
                    for (i = 0; i < exception.existingnodesinfo.length; i++) {
                        existingFilenames.push(exception.existingnodesinfo[i].name);
                    }
                }

                this.conflictConfirmWin = Tine.widgets.dialog.FileListDialog.openWindow({
                    modal: true,
                    allowCancel: false,
                    height: 180,
                    width: 300,
                    title: app.i18n._('Files already exists') + '. ' + app.i18n._('Do you want to replace the following file(s)?'),
                    text: existingFilenames.join('<br />'),
                    scope: this,
                    handler: function(button) {
                        var params = request.params,
                            uploadKey = exception.uploadKeyArray;
                        params.method = request.method;
                        params.forceOverwrite = true;

                        if (button == 'no') {
                            if (params.method == 'MailFiler.moveNodes') {
                                // reload grid
                                var app = Tine.Tinebase.appMgr.get('MailFiler');
                                app.getMainScreen().getCenterPanel().grid.getStore().reload();
                                // do nothing, other nodes has been moved already
                                return;
                            }
                            
                            Tine.log.debug('Tine.MailFiler.handleRequestException::' + params.method + ' -> only non-existant nodes.');
                            
                            Ext.each(params.filenames, function(filename) {
                                filenameWithoutPath = filename.match(/[^\/]*$/);
                                if (filenameWithoutPath && existingFilenames.indexOf(filenameWithoutPath[0]) === -1) {
                                    nonExistantFilenames.push(filename);
                                }
                            });
                            
                            params.filenames = nonExistantFilenames;
                            
                            uploadKey = nonExistantFilenames;
                        } else {
                            Tine.log.debug('Tine.MailFiler.handleRequestException::' + params.method + ' -> replace all existing nodes.');
                        }

                        if (params.method == 'MailFiler.copyNodes' || params.method == 'MailFiler.moveNodes' ) {
                            Tine.MailFiler.fileRecordBackend.copyNodes(null, null, null, params);
                        } else if (params.method == 'MailFiler.createNodes' ) {
                            Tine.MailFiler.fileRecordBackend.createNodes(params, uploadKey, exception.addToGridStore);
                        }
                    }
                });

            } else {
                Ext.Msg.show({
                  title:   app.i18n._('Failure on create folder'),
                  msg:     app.i18n._('Item with this name already exists!'),
                  icon:    Ext.MessageBox.ERROR,
                  buttons: Ext.Msg.OK
               });
            }
            break;
        case 902: // MailFiler_Exception_DestinationIsOwnChild
            Ext.MessageBox.show({
                buttons: Ext.Msg.OK,
                icon: Ext.MessageBox.ERROR,
                title: app.i18n._(exception.title),
                msg: app.i18n._(exception.message)
            });
            break;
        case 903: // MailFiler_Exception_DestinationIsSameNode
            Ext.MessageBox.show({
                buttons: Ext.Msg.OK,
                icon: Ext.MessageBox.INFO,
                title: app.i18n._(exception.title),
                msg: app.i18n._(exception.message)
            });
            break;
        default:
            Tine.Tinebase.ExceptionHandler.handleRequestException(exception);
            break;
    }
};

/***/ }),

/***/ 772:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Martin Jatho <m.jatho@metaways.de>
 * @copyright   Copyright (c) 2007-2012 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.ns('Tine.MailFiler');

    
Tine.MailFiler.GridContextMenu = {
    /**
     * create tree node
     */
    addNode: function() {
        Tine.log.debug("grid add");
    },
    
    /**
     * rename tree node
     */
    renameNode: function() {
        if (this.scope.ctxNode) {
            
            var node = this.scope.ctxNode[0];
            
            var nodeText = node.data.name;
            if(typeof nodeText == 'object') {
                nodeText = nodeText.name;
            }
            
            Ext.MessageBox.show({
                title: 'Rename ' + this.nodeName,
                msg: String.format(i18n._('Please enter the new name of the {0}:'), this.nodeName),
                buttons: Ext.MessageBox.OKCANCEL,
                value: nodeText,
                fn: function(_btn, _text){
                    if (_btn == 'ok') {
                        if (! _text) {
                            Ext.Msg.alert(String.format(i18n._('Not renamed {0}'), this.nodeName), String.format(i18n._('You have to supply a {0} name!'), this.nodeName));
                            return;
                        }
                        
                        var params = {
                                method: this.backend + '.rename' + this.backendModel,
                                newName: _text
                        };
                        
                        if (this.backendModel == 'Node') {
                            params.application = this.scope.app.appName || this.scope.appName;
                            var filename = node.data.path;
                            params.sourceFilenames = [filename];
                            
                            var targetFilename = "/";
                            var sourceSplitArray = filename.split("/");
                            for (var i=1; i<sourceSplitArray.length-1; i++) {
                                targetFilename += sourceSplitArray[i] + '/';
                            }
                            
                            params.destinationFilenames = [targetFilename + _text];
                            params.method = this.backend + '.moveNodes';
                        }
                        
                        Ext.Ajax.request({
                            params: params,
                            scope: this,
                            success: function(_result, _request){
                                var nodeData = Ext.util.JSON.decode(_result.responseText)[0];
                                this.scope.fireEvent('containerrename', nodeData);
                                
                                // TODO: im event auswerten
                                if (this.backendModel == 'Node') {
                                    var grid = this.scope.app.getMainScreen().getCenterPanel();
                                    grid.getStore().reload();
                                    
                                    var nodeName = nodeData.name;
                                    if(typeof nodeName == 'object') {
                                        nodeName = nodeName.name;
                                    }
                                    
                                    var treeNode = this.scope.app.getMainScreen().getWestPanel().getContainerTreePanel().getNodeById(nodeData.id);
                                    if(treeNode) {
                                        treeNode.setText(nodeName);
                                        treeNode.attributes.nodeRecord.beginEdit();
                                        treeNode.attributes.nodeRecord.set('name', nodeName); // TODO set path
                                        treeNode.attributes.nodeRecord.set('path', nodeData.path); // TODO set path
                                        treeNode.attributes.path = nodeData.path; // TODO set path
                                        treeNode.attributes.nodeRecord.commit(false);
                                        
                                        if(typeof treeNode.attributes.name == 'object') {
                                            treeNode.attributes.name.name = nodeName; // TODO set path
                                        }
                                        else {
                                            treeNode.attributes.name = nodeName;
                                        }
                                    }
                                }
                            },
                            failure: function(result, request) {
                                var nodeData = Ext.util.JSON.decode(result.responseText);
                                
                                var appContext = Tine[this.scope.app.appName];
                                if(appContext && appContext.handleRequestException) {
                                    appContext.handleRequestException(nodeData.data);
                                }
                            }
                        });
                    }
                },
                scope: this,
                prompt: true,
                icon: Ext.MessageBox.QUESTION
            });
        }
    },
    
    /**
     * delete tree node
     */
    deleteNode: function() {
        if (this.scope.ctxNode) {
            var nodes = this.scope.ctxNode;
            
            var nodeName = "";
            if(nodes && nodes.length) {
                for(var i=0; i<nodes.length; i++) {
                    var currNodeData = nodes[i].data;

                    nodeName += Ext.util.Format.htmlEncode(typeof currNodeData.name == 'object' ?
                        currNodeData.name.name :
                        currNodeData.name) + '<br />';
                }
            }
            
            this.conflictConfirmWin = Tine.widgets.dialog.FileListDialog.openWindow({
                modal: true,
                allowCancel: false,
                height: 180,
                width: 300,
                title: this.scope.app.i18n._('Do you really want to delete the following files?'),
                text: nodeName,
                scope: this,
                handler: function(button){
                    if (button == 'yes') {
                        var params = {
                                method: this.backend + '.delete' + this.backendModel
                        };
                        
                        if (this.backendModel == 'Node') {
                            
                            var filenames = new Array();
                            if(nodes) {
                                for(var i=0; i<nodes.length; i++) {
                                    filenames.push(nodes[i].data.path);
                                }
                            }
                            params.application = this.scope.app.appName || this.scope.appName;
                            params.filenames = filenames;
                            params.method = this.backend + ".deleteNodes";
                        }
                        
                        Ext.Ajax.request({
                            params: params,
                            scope: this,
                            success: function(_result, _request){
                                
                                if(nodes &&  this.backendModel == 'Node') {
                                    var treePanel = this.scope.app.getMainScreen().getWestPanel().getContainerTreePanel();
                                    for(var i=0; i<nodes.length; i++){
                                        treePanel.fireEvent('containerdelete', nodes[i].data.container_id);
                                        // TODO: in EventHandler auslagern
                                        var treeNode = treePanel.getNodeById(nodes[i].id);
                                        if(treeNode) {
                                            treeNode.parentNode.removeChild(treeNode);
                                        }
                                    }
                                    for(var i=0; i<nodes.length; i++) {
                                        var node = nodes[i];
                                        if(node.fileRecord) {
                                            var upload = Tine.Tinebase.uploadManager.getUpload(node.fileRecord.get('uploadKey'));
                                            upload.setPaused(true);
                                            Tine.Tinebase.uploadManager.unregisterUpload(upload.id);
                                        }
                                    }
                                    this.scope.app.getMainScreen().getCenterPanel().getStore().remove(nodes);
                                }
                            },
                            failure: function(result, request) {
                                var nodeData = Ext.util.JSON.decode(result.responseText);
                                
                                var appContext = Tine[this.scope.app.appName];
                                if(appContext && appContext.handleRequestException) {
                                    appContext.handleRequestException(nodeData.data);
                                }
                            }
                        });
                    }
    
                }
            });

        }
    },
    
    /**
     * change tree node color
     */
    changeNodeColor: function(cp, color) {
        Tine.log.debug("grid change color");
    },
    
    /**
     * manage permissions
     * 
     */
    managePermissions: function() {
        Tine.log.debug("grid manage permissions");
    },
    
    /**
     * publish file
     */
    publishFile: function() {
        var app = Tine.Tinebase.appMgr.get('MailFiler');
        var grid = app.getMainScreen().getCenterPanel();
        grid.onPublishFile.call(grid);
    },
    
    /**
     * reload node
     */
    reloadNode: function() {
        Tine.log.debug("grid reload node");
    },
    
    /**
     * calls the file edit dialog from the grid
     * @param {} button
     * @param {} event
     */
    onEditFile: function(button, event) {
        var app = Tine.Tinebase.appMgr.get('MailFiler');
        var grid = app.getMainScreen().getCenterPanel();
        grid.onEditFile.call(grid);
    },
    
    /**
     * download file
     * 
     * @param {} button
     * @param {} event
     *
     * @todo use Tine.Filemanager.downloadFile
     */
    downloadFile: function(button, event) {
        
        var grid = this.scope.app.getMainScreen().getCenterPanel();
        var selectedRows = grid.selectionModel.getSelections();
        
        var fileRow = selectedRows[0];
               
        var downloadPath = fileRow.data.path;
        var downloader = new Ext.ux.file.Download({
            params: {
                method: 'MailFiler.downloadFile',
                requestType: 'HTTP',
                id: '',
                path: downloadPath
            }
        }).start();
    },
    
    /**
     * is the download context menu option visible / enabled
     * 
     * @param action
     * @param grants
     * @param records
     */
    isDownloadEnabled: function(action, grants, records) {
        for(var i=0; i<records.length; i++) {
            if(records[i].data.type === 'folder') {
                action.hide();
                return;
            }
        }
        action.show();
        
        var grid = this.scope.app.getMainScreen().getCenterPanel();
        var selectedRows = grid.selectionModel.getSelections();
        
        if(selectedRows.length > 1) {
            action.setDisabled(true);
        }
        else {
            action.setDisabled(false);
        }
        
    }
};

// extends Tine.widgets.tree.ContextMenu
Ext.applyIf(Tine.MailFiler.GridContextMenu, Tine.widgets.tree.ContextMenu);


/***/ }),

/***/ 773:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 * 
 * @package     MailFiler
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2009-2017 Metaways Infosystems GmbH (http://www.metaways.de)
 */
 
Ext.ns('Tine.MailFiler');

/**
 * @namespace   Tine.MailFiler
 * @class       Tine.MailFiler.GridDetailsPanel
 * @extends     Tine.widgets.grid.DetailsPanel
 * 
 * <p>Message Grid Details Panel</p>
 * <p>the details panel (shows message content)</p>
 * 
 * @param       {Object} config
 * @constructor
 * Create a new Tine.MailFiler.GridDetailsPanel
 *
 * @todo        extend Tine.Felamimail.GridDetailsPanel to re-use message functionality
 */
 Tine.MailFiler.GridDetailsPanel = Ext.extend(Tine.widgets.grid.DetailsPanel, {
    
    /**
     * config
     * @private
     */
    defaultHeight: 350,
    currentId: null,
    record: null,
    app: null,
    i18n: null,
    
    fetchBodyTransactionId: null,
    
    /**
     * init
     * @private
     */
    initComponent: function() {
        this.initTemplate();
        this.initDefaultTemplate();

        Tine.MailFiler.GridDetailsPanel.superclass.initComponent.call(this);
    },

    /**
     * use default Tpl for default and multi view
     */
    initDefaultTemplate: function() {
        this.defaultTpl = new Ext.XTemplate(
            '<div class="preview-panel-felamimail">',
                '<div class="preview-panel-felamimail-body">{[values ? values.msg : ""]}</div>',
            '</div>'
        );
    },
    
    /**
     * add on click event after render
     * @private
     */
    afterRender: function() {
        Tine.MailFiler.GridDetailsPanel.superclass.afterRender.apply(this, arguments);
        this.body.on('click', this.onClick, this);
    },
    
    /**
     * get panel for single record details
     * 
     * @return {Ext.Panel}
     */
    getSingleRecordPanel: function() {
        if (! this.singleRecordPanel) {
            this.singleRecordPanel = new Ext.Panel({
                layout: 'vbox',
                layoutConfig: {
                    align:'stretch'
                },
                border: false,
                items: [
                    this.getMessageRecordPanel()
                ]
            });
        }
        return this.singleRecordPanel;
    },

    /**
     * get panel for single record details
     * 
     * @return {Ext.Panel}
     */
    getMessageRecordPanel: function() {
        if (! this.messageRecordPanel) {
            this.messageRecordPanel = new Ext.Panel({
                border: false,
                autoScroll: true,
                flex: 1
            });
        }
        return this.messageRecordPanel;
    },
    
    /**
     * (on) update details
     * 
     * @param {Tine.MailFiler.Model.Node} record
     * @param {String} body
     * @private
     */
    updateDetails: function(record, body) {
        if (record.get('message') && Ext.isObject(record.get('message'))) {
            if (record.id === this.currentId) {
                // nothing to do
            } else if (! record.messageIsFetched()) {
                this.waitForContent(record, this.getMessageRecordPanel().body);
            } else {
                // FIXME update record in grid: currently the record is overwritten after the message was fetched ...
                this.record = record;
                this.attachments = this.record.get('message').attachments;
                this.currentId = record.id;
                this.setTemplateContent(this.record.get('message'), this.getMessageRecordPanel().body);
            }
        } else {
            this.layout.setActiveItem(this.getDefaultInfosPanel());
            this.showDefault(this.getDefaultInfosPanel().body);
            this.record = null;
        }
    },

     /**
      * wait for body content
      *
      * @param {Tine.MailFiler.Model.Node} record
      * @param {String} body
      */
     waitForContent: function(record, body) {
         if (! this.grid || this.grid.getSelectionModel().getCount() == 1) {
             this.refetchBody(record, {
                 success: this.updateDetails.createDelegate(this, [record, body]),
                 failure: function (exception) {
                     Tine.log.debug(exception);
                     this.getLoadMask().hide();
                     if (exception.code == 404) {
                         this.defaultTpl.overwrite(body, {msg: this.app.i18n._('Message not available.')});
                     } else {
                         Tine.MailFiler.fileRecordBackend.handleRequestException(exception);
                     }
                 },
                 scope: this
             });
             this.defaultTpl.overwrite(body, {msg: ''});
             this.getLoadMask().show();
         } else {
             this.getLoadMask().hide();
         }
     },

     /**
      * refetch message body
      *
      * @param {MailFiler model} record
      * @param {Function} callback
      * 
      * @todo switch to MailFiler functions
      */
     refetchBody: function(record, callback) {
         // cancel old request first
         if (this.fetchBodyTransactionId && ! Tine.MailFiler.fileRecordBackend.isLoading(this.fetchBodyTransactionId)) {
             Tine.log.debug('Tine.MailFiler.GridDetailsPanel::refetchBody -> cancelling current fetchBody request.');
             Tine.MailFiler.fileRecordBackend.abort(this.fetchBodyTransactionId);
         }
         Tine.log.debug('Tine.MailFiler.GridDetailsPanel::refetchBody -> calling fetchBody');
         this.fetchBodyTransactionId = Tine.MailFiler.fileRecordBackend.fetchBody(record, 'configured', callback);
     },

     /**
     * overwrite template with (body) content
     *
     * @param {Object} messageData
     * @param {String} body
     */
    setTemplateContent: function(messageData, body) {
        this.getLoadMask().hide();
        this.doLayout();
        this.tpl.overwrite(body, messageData);

        this.getEl().down('div').down('div').scrollTo('top', 0, false);
    },

    /**
     * init single message template (this.tpl)
     * @private
     */
    initTemplate: function() {
        
        this.tpl = new Ext.XTemplate(
            '<div class="preview-panel-felamimail">',
                '<div class="preview-panel-felamimail-headers">',
                    '<b>' + this.i18n._('Subject') + ':</b> {[this.encode(values.subject)]}<br/>',
                    '<b>' + this.i18n._('From') + ':</b>',
                    ' {[this.showFrom(values.from_email, values.from_name, "' + this.i18n._('Add') + '", "' 
                        + this.i18n._('Add contact to addressbook') + '")]}<br/>',
                    '<b>' + this.i18n._('Date') + ':</b> {[this.showDate(values.sent, values)]}',
                    '{[this.showRecipients(values.headers)]}',
                    //'{[this.showHeaders("' + this.i18n._('Show or hide header information') + '")]}',
                '</div>',
                '<div class="preview-panel-felamimail-attachments">{[this.showAttachments(values.attachments, values)]}</div>',
                '<div class="preview-panel-felamimail-body">{[this.showBody(values.body, values)]}</div>',
            '</div>',{
            app: this.app,
            panel: this,
            encode: function(value) {
                if (value) {
                    var encoded = Ext.util.Format.htmlEncode(value);
                    encoded = Ext.util.Format.nl2br(encoded);
                    // it should be enough to replace only 2 or more spaces
                    encoded = encoded.replace(/ /g, '&nbsp;');
                    
                    return encoded;
                } else {
                    return '';
                }
                return value;
            },
            
            showDate: function(sent, messageData) {
                var date = (sent) ? sent : messageData.received;
                return (date)
                    ? (Ext.isFunction(date.format) ? date.format('l') + ', ' + Tine.Tinebase.common.dateTimeRenderer(date) : date)
                    : '';
            },
            
            showFrom: function(email, name, addText, qtip) {
                if (! name) {
                    name = '';
                }
                
                var result = this.encode(name + ' <' + email + '>');
                
                // add link with 'add to contacts'
                var id = Ext.id() + ':' + email;
                
                var nameSplit = name.match(/^"*([^,^ ]+)(,*) *(.+)/i);
                var firstname = (nameSplit && nameSplit[1]) ? nameSplit[1] : '';
                var lastname = (nameSplit && nameSplit[3]) ? nameSplit[3] : '';
                if (nameSplit && nameSplit[2] == ',') {
                    firstname = lastname;
                    lastname = nameSplit[1];
                }
                
                id += Ext.util.Format.htmlEncode(':' + Ext.util.Format.trim(firstname) + ':' + Ext.util.Format.trim(lastname));
                //result = '<a id="' + id + '" class="tinebase-email-link">' + result + '</a>'
                //result += ' <span ext:qtip="' + Tine.Tinebase.common.doubleEncode(qtip) + '" id="' + id + '" class="tinebase-addtocontacts-link">[+]</span>';
                return result;
            },
            
            showBody: function(body, messageData) {
                body = body || '';
                if (body && messageData.body_content_type == 'text/plain') {

                    var width = this.panel.body.getWidth()-25,
                        height = this.panel.body.getHeight()-90,
                        id = Ext.id();

                    if (height < 0) {
                        // sometimes the height is negative, fix this here
                        height = 500;
                    }

                    body = '<textarea ' +
                        'style="width: ' + width + 'px; height: ' + height + 'px; " ' +
                        'autocomplete="off" id="' + id + '" name="body" class="x-form-textarea x-form-field x-ux-display-background-border" readonly="" >' +
                        body + '</textarea>';
                } else {
                    body = Ext.util.Format.nl2br(body);
                }
                return body;
            },
            
            showHeaders: function(qtip) {
                var result = ' <span ext:qtip="' + Tine.Tinebase.common.doubleEncode(qtip) + '" id="' + Ext.id() + ':show" class="tinebase-showheaders-link">[...]</span>';
                return result;
            },
            
            showRecipients: function(value) {
                if (value) {
                    var i18n = Tine.Tinebase.appMgr.get('MailFiler').i18n,
                        result = '';
                    for (header in value) {
                        if (value.hasOwnProperty(header) && (header == 'to' || header == 'cc' || header == 'bcc')) {
                            result += '<br/><b>' + i18n._hidden(Ext.util.Format.capitalize(header)) + ':</b> ' 
                                + Ext.util.Format.htmlEncode(value[header]);
                        }
                    }
                    return result;
                } else {
                    return '';
                }
            },
            
            showAttachments: function(attachments, messageData) {
                var result = (attachments && attachments.length > 0) ? '<b>' + this.app.i18n._('Attachments') + ':</b> ' : '';

                if (attachments) {
                    for (var i = 0, id, cls; i < attachments.length; i++) {
                        result += '<span id="' + Ext.id() + ':' + i + '" class="tinebase-download-link">'
                            + '<i>' + attachments[i].filename + '</i>'
                            + ' (' + Ext.util.Format.fileSize(attachments[i].size) + ')</span> ';
                    }
                }
                
                return result;
            }
        });
    },
    
    /**
     * on click for attachment download / compose dlg / edit contact dlg
     * 
     * @param {} e
     * @private
     */
    onClick: function(e) {
        var selectors = [
            'span[class=tinebase-download-link]',
            'a[class=tinebase-email-link]',
            'span[class=tinebase-addtocontacts-link]',
            'span[class=tinebase-showheaders-link]'
        ];
        
        // find the correct target
        for (var i=0, target=null, selector=''; i < selectors.length; i++) {
            target = e.getTarget(selectors[i]);
            if (target) {
                selector = selectors[i];
                break;
            }
        }
        
        Tine.log.debug('Tine.MailFiler.GridDetailsPanel::onClick found target:"' + selector + '".');
        
        switch (selector) {
            case 'span[class=tinebase-download-link]':
                var idx = target.id.split(':')[1],
                    // FIXME: somehow the message in the record is not persisted - this.attachments should be removed
                    // FIXME:   when this is working correctly
                    // attachment = this.record.get('message').attachments !== undefined
                    //    ? this.record.get('message').attachments[idx]
                    //    : null,
                    attachment = this.attachments !== undefined
                        ? this.attachments[idx]
                        : null,
                    nodeId = this.record.get('id');

                // TODO support 'message/rfc822'?
                // remove part id if set (that is the case in message/rfc822 attachments)
                //var messageId = (this.record.get('message').id.match(/_/)) ? this.record.get('message').id.split('_')[0] : this.record.get('message').messageuid;
                //if (attachment['content-type'] === 'message/rfc822') {
                //
                //    Tine.log.debug('Tine.MailFiler.GridDetailsPanel::onClick openWindow for:"' + messageId + '_' + attachment.partId + '".');
                //    // display message
                //    Tine.MailFiler.MessageDisplayDialog.openWindow({
                //        record: new Tine.MailFiler.Model.Message({
                //            id: messageId + '_' + attachment.partId
                //        })
                //    });
                //
                //} else {

                // download attachment
                if (attachment) {
                    new Ext.ux.file.Download({
                        params: {
                            requestType: 'HTTP',
                            method: 'MailFiler.downloadAttachment',
                            path: this.record.get('path'),
                            nodeId: nodeId,
                            partId: attachment.partId
                        }
                    }).start();
                } else {
                    Tine.log.warn('Attachment not found');
                }

                break;
        }
    }
});


/***/ }),

/***/ 774:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Cornelius Weiss <c.weiss@metaways.de>
 * @copyright   Copyright (c) 2007-2017 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.ns('Tine.MailFiler.Model');
    
/**
 * @namespace   Tine.MailFiler.Model
 * @class       Tine.MailFiler.Model.Node
 * @extends     Tine.Tinebase.data.Record
 * Example record definition
 * 
 * @author      Cornelius Weiss <c.weiss@metaways.de>
 */
Tine.MailFiler.Model.Node = Tine.Tinebase.data.Record.create(Tine.Tinebase.Model.Tree_NodeArray.concat([
    { name: 'message'},
    // needed for sorting in grid
    { name: 'to_flat'},
    { name: 'sent'},
    { name: 'subject'},
    { name: 'received'},
    { name: 'from_name'},
    { name: 'from_email'}
]), {
    appName: 'MailFiler',
    modelName: 'Node',
    idProperty: 'id',
    titleProperty: 'name',
    // ngettext('File', 'Files', n); gettext('File');
    recordName: 'File',
    recordsName: 'Files',
    // ngettext('Folder', 'Folders', n); gettext('Folder');
    containerName: 'Folder',
    containersName: 'Folders',
    
    /**
     * virtual nodes are part of the tree but don't exists / are editable
     *
     * NOTE: only "real" virtual node is node with path "otherUsers". all other nodes exist
     *
     * @returns {boolean}
     */
    isVirtual: function() {
        var _ = window.lodash;

        return _.indexOf(['/', Tine.Tinebase.container.getMyFileNodePath(), '/personal', '/shared'], this.get('path')) >= 0;
    },

    /**
     * @returns {boolean}
     */
    messageIsFetched: function() {
        return this.get('message') !== undefined && this.get('message').body !== undefined;
    }
});
    
/**
 * create Node from File
 * 
 * @param {File} file
 */
Tine.MailFiler.Model.Node.createFromFile = function(file) {
    return new Tine.MailFiler.Model.Node({
        name: file.name ? file.name : file.fileName,  // safari and chrome use the non std. fileX props
        size: file.size || 0,
        type: 'file',
        contenttype: file.type ? file.type : file.fileType, // missing if safari and chrome 
        revision: 0
    });
};

/**
 * file record backend
 */
Tine.MailFiler.fileRecordBackend = new Tine.Filemanager.FileRecordBackend({
    appName: 'MailFiler',
    modelName: 'Node',
    recordClass: Tine.MailFiler.Model.Node,

    /**
     * fetches body and additional headers (which are needed for the preview panel) into given message
     *
     * @param {Message} message
     * @param {String} mimeType
     * @param {Function|Object} callback (NOTE: this has NOTHING to do with standard Ext request callback fn)
     *
     * @todo use mimeType?
     */
    fetchBody: function(record, mimeType, callback) {

        // if (mimeType == 'configured') {
        //     var account = Tine.Tinebase.appMgr.get('Felamimail').getAccountStore().getById(message.get('account_id'));
        //     if (account) {
        //         mimeType = account.get('display_format');
        //         if (!mimeType.match(/^text\//)) {
        //             mimeType = 'text/' + mimeType;
        //         }
        //     } else {
        //         // no account found, might happen for .eml emails
        //         mimeType = 'text/plain';
        //     }
        // }

        return this.loadRecord(record, {
            //params: {mimeType: mimeType},
            timeout: 120000, // 2 minutes
            suppressBusEvents: true,
            scope: this,
            success: function(response, options) {
                var nodeWithBody = this.recordReader({responseText: Ext.util.JSON.encode(response.data)});
                Ext.copyTo(record.data, nodeWithBody.data, ['message']);
                if (Ext.isFunction(callback)) {
                    callback(record);
                } else if (callback.success) {
                    Ext.callback(callback.success, callback.scope, [record]);
                }
            },
            failure: function(exception) {
                if (callback.failure) {
                    Ext.callback(callback.failure, callback.scope, [exception]);
                } else {
                    this.handleRequestException(exception);
                }
            }
        });
    }
});


/**
 * get filtermodel of Node records
 * 
 * @namespace Tine.MailFiler.Model
 * @static
 * @return {Object} filterModel definition
 */ 
Tine.MailFiler.Model.Node.getFilterModel = function() {
    var app = Tine.Tinebase.appMgr.get('MailFiler');
       
    return [
        {label : i18n._('Quick Search'), field : 'query', operators : [ 'contains' ]},
//        {label: app.i18n._('Type'), field: 'type'}, // -> should be a combo
        {label: app.i18n._('Contenttype'), field: 'contenttype'},
        {label: app.i18n._('Creation Time'), field: 'creation_time', valueType: 'date'},
        {label: app.i18n._('Description'), field: 'description', valueType: 'fulltext'},
        {filtertype : 'tine.filemanager.pathfiltermodel', app : app}, 
        {filtertype : 'tinebase.tag', app : app},
        {label: app.i18n._('Subject'),     field: 'subject',       operators: ['contains']},
        {label: app.i18n._('From (Email)'),field: 'from_email',    operators: ['contains']},
        {label: app.i18n._('From (Name)'), field: 'from_name',     operators: ['contains']},
        // TODO hide "to" or to_flat here?
        {label: app.i18n._('To'),          field: 'to',            operators: ['contains']},
        //{label: app.i18n._('To Flat'),     field: 'to_flat',       operators: ['contains']},
        {label: app.i18n._('Cc'),          field: 'cc',            operators: ['contains']},
        {label: app.i18n._('Bcc'),         field: 'bcc',           operators: ['contains']},
        {label: app.i18n._('Flags'),       field: 'flags',         filtertype: 'tinebase.multiselect', app: app, multiselectFieldConfig: {
            valueStore: Tine.Felamimail.loadFlagsStore()
        }},
        {label: app.i18n._('Received'),    field: 'received',      valueType: 'date', pastOnly: true}
    ];
};


/***/ }),

/***/ 775:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2007-2016 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.ns('Tine.MailFiler')

/**
 * Folder select ComboBox widget
 * 
 * @namespace   Tine.MailFiler
 * @class       Tine.MailFiler.folderSelectComboBox
 * @extends     Tine.widgets.container.SelectionComboBox
 *
 * TODO implement
 */
Tine.MailFiler.folderSelectComboBox = Ext.extend(Tine.widgets.container.SelectionComboBox, {
    /**
     * @cfg {Tine.data.Record} recordClass
     */
    recordClass: Tine.MailFiler.Model.Node
});

Ext.reg('foldertcombo', Tine.MailFiler.folderSelectComboBox);



/***/ }),

/***/ 776:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 * MailFiler combo box and store
 * 
 * @package     MailFiler
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Alexander Stintzing <a.stintzing@metaways.de>
 * @copyright   Copyright (c) 2012 Metaways Infosystems GmbH (http://www.metaways.de)
 *
 */

Ext.ns('Tine.MailFiler');

/**
 * Node selection combo box
 * 
 * @namespace   Tine.MailFiler
 * @class       Tine.MailFiler.SearchCombo
 * @extends     Ext.form.ComboBox
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Alexander Stintzing <a.stintzing@metaways.de>
 * @copyright   Copyright (c) 2012 Metaways Infosystems GmbH (http://www.metaways.de)
 * 
 * @param       {Object} config
 * @constructor
 * Create a new Tine.MailFiler.SearchCombo
 */
Tine.MailFiler.SearchCombo = Ext.extend(Tine.Tinebase.widgets.form.RecordPickerComboBox, {
    
    allowBlank: false,
    itemSelector: 'div.search-item',
    minListWidth: 200,
    
    //private
    initComponent: function(){
        this.recordClass = Tine.MailFiler.Model.Node;
        this.recordProxy = Tine.MailFiler.recordBackend;
        this.additionalFilters = [
            {field: 'recursive', operator: 'equals', value: true },
            {field: 'path', operator: 'equals', value: '/' }
        ];
        this.initTemplate();
        Tine.MailFiler.SearchCombo.superclass.initComponent.call(this);
    },
    
    /**
     * init template
     * @private
     */
    initTemplate: function() {
        // Custom rendering Template
        // TODO move style def to css ?
        if (! this.tpl) {
            this.tpl = new Ext.XTemplate(
                '<tpl for="."><div class="search-item">',
                    '<table cellspacing="0" cellpadding="2" border="0" style="font-size: 11px;" width="100%">',
                        '<tr>',
                            '<td ext:qtip="{[this.renderPathName(values)]}" style="height:16px">{[this.renderFileName(values)]}</td>',
                        '</tr>',
                    '</table>',
                '</div></tpl>',
                {
                    renderFileName: function(values) {
                        return Ext.util.Format.htmlEncode(values.name);
                    },
                    renderPathName: function(values) {
                        return Ext.util.Format.htmlEncode(values.path.replace(values.name, ''));
                    }
                    
                }
            );
        }
    },
    
    getValue: function() {
            return Tine.MailFiler.SearchCombo.superclass.getValue.call(this);
    },

    setValue: function (value) {
        return Tine.MailFiler.SearchCombo.superclass.setValue.call(this, value);
    }

});

Tine.widgets.form.RecordPickerManager.register('MailFiler', 'Node', Tine.MailFiler.SearchCombo);


/***/ }),

/***/ 777:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 *
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Alexander Stintzing <a.stintzing@metaways.de>
 * @copyright   Copyright (c) 2012-2014 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.ns('Tine.MailFiler');

/**
 * @namespace   Tine.MailFiler
 * @class       Tine.MailFiler.NodeEditDialog
 * @extends     Tine.widgets.dialog.EditDialog
 *
 * <p>Node Compose Dialog</p>
 * <p></p>
 *
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Alexander Stintzing <a.stintzing@metaways.de>
 *
 * @param       {Object} config
 * @constructor
 * Create a new Tine.MailFiler.NodeEditDialog
 */
Tine.MailFiler.NodeEditDialog = Ext.extend(Tine.widgets.dialog.EditDialog, {

    /**
     * @private
     */
    windowNamePrefix: 'NodeEditWindow_',
    appName: 'MailFiler',
    recordClass: Tine.MailFiler.Model.Node,
    recordProxy: Tine.MailFiler.fileRecordBackend,
    tbarItems: null,
    evalGrants: true,
    showContainerSelector: false,
    displayNotes: true,
    mailDetailsPanel: null,

    /**
     * @type Tine.MailFiler.DownloadLinkGridPanel
     */
    initComponent: function () {
        this.app = Tine.Tinebase.appMgr.get('MailFiler');
        this.downloadAction = new Ext.Action({
            requiredGrant: 'readGrant',
            allowMultiple: false,
            actionType: 'download',
            text: this.app.i18n._('Save locally'),
            handler: this.onDownload,
            iconCls: 'action_filemanager_save_all',
            disabled: false,
            scope: this
        });
        this.printAction = new Ext.Action({
            requiredGrant: 'readGrant',
            text: this.app.i18n._('Print Message'),
            handler: this.onPrint.createDelegate(this, []),
            disabled: false,
            iconCls:'action_print',
            scope:this
        });

        this.tbarItems = [this.downloadAction, this.printAction];

        Tine.MailFiler.NodeEditDialog.superclass.initComponent.call(this);
    },

    /**
     * Ripped of felamimail
     *
     * @param detailsPanel
     */
    onPrint: function() {
        var id = Ext.id(),
            doc = document,
            frame = doc.createElement('iframe');

        Ext.fly(frame).set({
            id: id,
            name: id,
            style: {
                position: 'absolute',
                width: '210mm',
                height: '297mm',
                top: '-10000px',
                left: '-10000px'
            }
        });

        doc.body.appendChild(frame);

        Ext.fly(frame).set({
            src : Ext.SSL_SECURE_URL
        });

        var doc = frame.contentWindow.document || frame.contentDocument || WINDOW.frames[id].document,
            content = this.getDetailsPanelContentForPrinting(this.mailDetailsPanel);

        doc.open();
        doc.write(content);
        doc.close();

        frame.contentWindow.focus();
        frame.contentWindow.print();
    },


    /**
     * get detail panel content
     *
     * @param {Tine.Felamimail.GridDetailsPanel} details panel
     * @return {String}
     */
    getDetailsPanelContentForPrinting: function(detailsPanel) {
        var detailsPanels = detailsPanel.getEl().query('.preview-panel-mail');

        var detailsPanelContent = (detailsPanels.length > 1) ? detailsPanels[1].innerHTML : detailsPanels[0].innerHTML;

        var buffer = '<html><head>';
        buffer += '<title>' + this.app.i18n._('Print Preview') + '</title>';
        buffer += '</head><body>';
        buffer += detailsPanelContent;
        buffer += '</body></html>';

        return buffer;
    },

    /**
     * folder or file?
     */
    getFittingTypeTranslation: function (isWindowTitle) {
        if (isWindowTitle) {
            return this.record.data.type == 'folder' ? this.app.i18n._('Edit folder') : this.app.i18n._('edit file');
        } else {
            return this.record.data.type == 'folder' ? this.app.i18n._('Folder') : this.app.i18n._('File');
        }
    },

    /**
     * executed when record is loaded
     * @private
     */
    onRecordLoad: function () {
        Tine.MailFiler.NodeEditDialog.superclass.onRecordLoad.apply(this, arguments);

        this.window.setTitle(this.getFittingTypeTranslation(true));

        this.mailDetailsPanel.loadRecord(this.record);
    },

    /**
     * download file
     */
    onDownload: function () {
        Tine.Filemanager.downloadFile(this.record, null, 'MailFiler');
    },

    /**
     * returns dialog
     * @return {Object}
     * @private
     */
    getFormItems: function () {
        var formFieldDefaults = {
            xtype: 'textfield',
            anchor: '100%',
            labelSeparator: '',
            columnWidth: .5,
            readOnly: true,
            disabled: true
        };

        this.mailDetailsPanel = new Tine.MailFiler.MailDetailsPanel({
            appName: this.appName
        });

        var grantsPanel = new Tine.Filemanager.GrantsPanel({
            app: this.app,
            editDialog: this
        });

        return {
            xtype: 'tabpanel',
            border: false,
            plain: true,
            plugins: [{
                ptype: 'ux.tabpanelkeyplugin'
            }],
            activeTab: 0,
            border: false,
            items: [{
                title: this.getFittingTypeTranslation(false),
                border: false,
                frame: true,
                layout: 'border',
                items: [{
                    region: 'center',
                    layout: 'vbox',
                    layoutConfig: {
                        align : 'stretch',
                        pack  : 'start'
                    },
                    border: false,
                    items: [{
                        xtype: 'fieldset',
                        layout: 'hfit',
                        height: 155,
                        // flex: 1,
                        title: this.getFittingTypeTranslation(false),
                        items: [{
                            xtype: 'columnform',
                            labelAlign: 'top',
                            formDefaults: formFieldDefaults,
                            items: [[{
                                fieldLabel: this.app.i18n._('Name'),
                                name: 'name',
                                allowBlank: false,
                                readOnly: false,
                                columnWidth: .75,
                                disabled: false
                            }, {
                                fieldLabel: this.app.i18n._('Type'),
                                name: 'contenttype',
                                columnWidth: .25
                            }], [
                                Tine.widgets.form.RecordPickerManager.get('Addressbook', 'Contact', {
                                    userOnly: true,
                                    useAccountRecord: true,
                                    blurOnSelect: true,
                                    fieldLabel: this.app.i18n._('Created By'),
                                    name: 'created_by'
                                }), {
                                    fieldLabel: this.app.i18n._('Creation Time'),
                                    name: 'creation_time',
                                    xtype: 'datefield'
                                }
                            ], [
                                Tine.widgets.form.RecordPickerManager.get('Addressbook', 'Contact', {
                                    userOnly: true,
                                    useAccountRecord: true,
                                    blurOnSelect: true,
                                    fieldLabel: this.app.i18n._('Modified By'),
                                    name: 'last_modified_by'
                                }), {
                                    fieldLabel: this.app.i18n._('Last Modified'),
                                    name: 'last_modified_time',
                                    xtype: 'datefield'
                                }
                            ]]
                        }]
                    }, {
                        layout: 'hfit',
                        autoScroll: true,
                        flex: 1,
                        items: [
                            this.mailDetailsPanel
                        ]
                    }]
                }, {
                    // activities and tags
                    layout: 'ux.multiaccordion',
                    animate: true,
                    region: 'east',
                    width: 210,
                    split: true,
                    collapsible: true,
                    collapseMode: 'mini',
                    header: false,
                    margins: '0 5 0 5',
                    border: true,
                    items: [
                        new Ext.Panel({
                            title: this.app.i18n._('Description'),
                            iconCls: 'descriptionIcon',
                            layout: 'form',
                            labelAlign: 'top',
                            border: false,
                            items: [{
                                style: 'margin-top: -4px; border 0px;',
                                labelSeparator: '',
                                xtype: 'textarea',
                                name: 'description',
                                hideLabel: true,
                                grow: false,
                                preventScrollbars: false,
                                anchor: '100% 100%',
                                emptyText: this.app.i18n._('Enter description'),
                                requiredGrant: 'editGrant'
                            }]
                        }),
                        new Tine.widgets.tags.TagPanel({
                            app: 'MailFiler',
                            border: false,
                            bodyStyle: 'border:1px solid #B5B8C8;'
                        })
                    ]
                }]
            },
            new Tine.widgets.activities.ActivitiesTabPanel({
                app: this.appName,
                record_id: this.record.id,
                record_model: 'Tinebase_Model_Tree_Node'
                }),
                // TODO include this?
                //{xtype: 'Tine.Filemanager.UsagePanel'},
                grantsPanel
            ]
        };
    }

});

/**
 * MailFiler Edit Popup
 *
 * @param   {Object} config
 * @return  {Ext.ux.Window}
 */
Tine.MailFiler.NodeEditDialog.openWindow = function (config) {
    var id = (config.record && config.record.id) ? config.record.id : 0;
    var window = Tine.WindowFactory.getWindow({
        width: 800,
        height: 570,
        name: Tine.MailFiler.NodeEditDialog.prototype.windowNamePrefix + id,
        contentPanelConstructor: 'Tine.MailFiler.NodeEditDialog',
        contentPanelConstructorConfig: config
    });

    return window;
};


/***/ }),

/***/ 778:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 *
 * @package     MailFiler
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Michael Spahn <m.spahn@metaways.de>
 * @copyright   Copyright (c) 2017 Metaways Infosystems GmbH (http://www.metaways.de)
 */

Ext.ns('Tine.MailFiler');

/**
 * @namespace   Tine.MailFiler
 * @class       Tine.MailFiler.MailDetailsPanel
 * @extends     Ext.Panel
 *
 * @todo: Improve this and use in Felamimail (this one is more configurable()
 */
Tine.MailFiler.MailDetailsPanel = Ext.extend(Ext.Panel, {
    record: null,
    app: null,
    appName: null,
    nodeRecord: null,

    initComponent: function () {
        this.app = Tine.Tinebase.appMgr.get(this.appName);
        Tine.MailFiler.MailDetailsPanel.superclass.initComponent.call(this);
    },

    /**
     * add on click event after render
     * @private
     */
    afterRender: function () {
        Tine.MailFiler.MailDetailsPanel.superclass.afterRender.apply(this, arguments);
        this.body.on('click', this.onClick, this);
    },

    /**
     * init single message template (this.tpl)
     */
    initTemplate: function () {
        var me = this;

        this.tpl = new Ext.XTemplate(
            '<div class="preview-panel-mail">',
            '<div class="preview-panel-mail-headers">',
            '<b>' + this.app.i18n._('Subject') + ':</b> {[this.encode(values.subject)]}<br/>',
            '<b>' + this.app.i18n._('From') + ':</b>',
            ' {[this.showFrom(values.from_email, values.from_name, "' + this.app.i18n._('Add') + '", "'
            + this.app.i18n._('Add contact to addressbook') + '")]}<br/>',
            '<b>' + this.app.i18n._('Date') + ':</b> {[this.showDate(values.sent, values)]}',
            '{[this.showRecipients(values.headers)]}',
            '{[this.showHeaders("' + this.app.i18n._('Show or hide header information') + '")]}',
            '</div>',
            '<div class="preview-panel-mail-attachments">{[this.showAttachments(values.attachments, values)]}</div>',
            '<div class="preview-panel-mail-body">{values.body}</div>',
            '</div>', {
                app: me.app,
                panel: me,
                encode: function (value) {
                    if (value) {
                        var encoded = Ext.util.Format.htmlEncode(value);
                        encoded = Ext.util.Format.nl2br(encoded);
                        // it should be enough to replace only 2 or more spaces
                        encoded = encoded.replace(/ /g, '&nbsp;');

                        return encoded;
                    } else {
                        return '';
                    }
                },

                showDate: function (sent, recordData) {
                    var date = sent ? Date.parseDate(sent, Date.patterns.ISO8601Long) : Date.parseDate(recordData.received, Date.patterns.ISO8601Long);
                    return date ? date.format('l') + ', ' + Tine.Tinebase.common.dateTimeRenderer(date) : '';
                },

                showFrom: function (email, name, addText, qtip) {
                    if (name === null || name === undefined) {
                        return '';
                    }

                    var result = this.encode(name + ' <' + email + '>');

                    // add link with 'add to contacts'
                    var id = Ext.id() + ':' + email;

                    var nameSplit = name.match(/^"*([^,^ ]+)(,*) *(.+)/i);
                    var firstname = (nameSplit && nameSplit[1]) ? nameSplit[1] : '';
                    var lastname = (nameSplit && nameSplit[3]) ? nameSplit[3] : '';
                    if (nameSplit && nameSplit[2] == ',') {
                        firstname = lastname;
                        lastname = nameSplit[1];
                    }

                    id += Ext.util.Format.htmlEncode(':' + Ext.util.Format.trim(firstname) + ':' + Ext.util.Format.trim(lastname));
                    result = '<a id="' + id + '" class="tinebase-email-link">' + result + '</a>'
                    result += ' <span ext:qtip="' + Tine.Tinebase.common.doubleEncode(qtip) + '" id="' + id + '" class="tinebase-addtocontacts-link">[+]</span>';
                    return result;
                },

                showHeaders: function (qtip) {
                    var result = ' <span ext:qtip="' + Tine.Tinebase.common.doubleEncode(qtip) + '" id="' + Ext.id() + ':show" class="tinebase-showheaders-link">[...]</span>';
                    return result;
                },

                showRecipients: function (value) {
                    if (value) {
                        var result = '';
                        for (header in value) {
                            if (value.hasOwnProperty(header) && (header == 'to' || header == 'cc' || header == 'bcc')) {
                                result += '<br/><b>' + this.app.i18n._hidden(Ext.util.Format.capitalize(header)) + ':</b> '
                                    + Ext.util.Format.htmlEncode(value[header]);
                            }
                        }
                        return result;
                    } else {
                        return '';
                    }
                },

                showAttachments: function (attachments) {
                    var result = '';

                    if (attachments && attachments.length > 0) {
                        result = '<b>' + this.app.i18n._('Attachments') + ':</b> ';

                        for (var i = 0, id; i < attachments.length; i++) {
                            result += '<span id="' + Ext.id() + ':' + i + '" class="tinebase-download-link">'
                                + '<i>' + attachments[i].filename + '</i>'
                                + ' (' + Ext.util.Format.fileSize(attachments[i].size) + ')</span> ';
                        }
                    }

                    return result;
                }
            });
        this.tpl.apply(this.record);
    },

    /**
     * on click for attachment download / compose dlg / edit contact dlg
     *
     * @private
     */
    onClick: function (e) {
        var selectors = [
            'span[class=tinebase-download-link]',
            'a[class=tinebase-email-link]',
            'span[class=tinebase-addtocontacts-link]',
            'span[class=tinebase-showheaders-link]'
        ];

        // find the correct target
        for (var i = 0, target = null, selector = ''; i < selectors.length; i++) {
            target = e.getTarget(selectors[i]);
            if (target) {
                selector = selectors[i];
                break;
            }
        }

        switch (selector) {
            case 'span[class=tinebase-download-link]':
                var idx = target.id.split(':')[1],
                    attachment = this.record.attachments[idx];

                // remove part id if set (that is the case in message/rfc822 attachments)
                var messageId = (this.record.id.match(/_/)) ? this.record.id.split('_')[0] : this.record.id;

                if (attachment['content-type'] === 'message/rfc822') {
                    // display message
                    var window = Tine.Felamimail.MessageDisplayDialog.openWindow({
                        message: new Tine.Felamimail.Model.Message({
                            id: messageId + '_' + attachment.partId
                        })
                    });

                } else {
                    new Ext.ux.file.Download({
                        params: {
                            requestType: 'HTTP',
                            method: 'MailFiler.downloadAttachment',
                            path: this.nodeRecord.data.path,
                            nodeId: this.record.node_id,
                            partId: attachment.partId
                        }
                    }).start();
                }

                break;

            case 'a[class=tinebase-email-link]':
                // open compose dlg
                var email = target.id.split(':')[1];
                var defaults = Tine.Felamimail.Model.Message.getDefaultData();
                defaults.to = [email];
                defaults.body = Tine.Felamimail.getSignature();

                var message = new Tine.Felamimail.Model.Message(defaults, 0);
                Tine.Felamimail.MessageEditDialog.openWindow({
                    message: message
                });
                break;

            case 'span[class=tinebase-addtocontacts-link]':
                // open edit contact dlg

                // check if addressbook app is available
                if (!Tine.Addressbook || !Tine.Tinebase.common.hasRight('run', 'Addressbook')) {
                    return;
                }

                var id = Ext.util.Format.htmlDecode(target.id);
                var parts = id.split(':');

                Tine.Addressbook.ContactEditDialog.openWindow({
                    listeners: {
                        scope: this,
                        'load': function (editdlg) {
                            editdlg.record.set('email', parts[1]);
                            editdlg.record.set('n_given', parts[2]);
                            editdlg.record.set('n_family', parts[3]);
                        }
                    }
                });

                break;

            case 'span[class=tinebase-showheaders-link]':
                // show headers

                var parts = target.id.split(':');
                var targetId = parts[0];
                var action = parts[1];

                var html = '';
                if (action == 'show') {
                    var messageHeaders = this.record.headers;

                    for (header in messageHeaders) {
                        if (messageHeaders.hasOwnProperty(header) && (header != 'to' || header != 'cc' || header != 'bcc')) {
                            html += '<br/><b>' + header + ':</b> '
                                + Ext.util.Format.htmlEncode(messageHeaders[header]);
                        }
                    }

                    target.id = targetId + ':' + 'hide';

                } else {
                    html = ' <span ext:qtip="' + Ext.util.Format.htmlEncode(this.app.i18n._('Show or hide header information')) + '" id="'
                        + Ext.id() + ':show" class="tinebase-showheaders-link">[...]</span>'
                }

                target.innerHTML = html;

                break;
        }
    },

    /**
     * fills this fields with the corresponding message data
     *
     * @param {Tine.Tinebase.data.Record} record
     */
    loadRecord: function (record) {
        this.record = record.data.hasOwnProperty('message') ? record.data.message : record;
        this.nodeRecord = record;
        this.initTemplate();
        this.update(this.record);
    }
});


/***/ }),

/***/ 779:
/***/ (function(module, exports, __webpack_require__) {

/*
 * Tine 2.0
 * 
 * @package     Tinebase
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2010-2017 Metaways Infosystems GmbH (http://www.metaways.de)
 */

Ext.ns('Tine.MailFiler');

__webpack_require__(780);

Tine.MailFiler.NodeTreePanel = Ext.extend(Tine.Filemanager.NodeTreePanel, {
    recordClass : Tine.MailFiler.Model.Node,

    /**
     * initiates tree context menus
     *
     * @private
     */
    initContextMenu: function() {
        this.ctxMenu = Tine.MailFiler.nodeContextMenu.getMenu({
            actionMgr: Tine.MailFiler.nodeActionsMgr,
            nodeName: this.recordClass.getContainerName(),
            actions: ['reload', 'createFolder', 'delete', 'rename', 'move' , 'edit'],
            scope: this,
            backend: 'MailFiler',
            backendModel: 'Node'
        });

        this.actionUpdater = new Tine.widgets.ActionUpdater({
            recordClass: this.recordClass,
            actions: this.ctxMenu.items
        });
    }
});


/***/ }),

/***/ 780:
/***/ (function(module, exports, __webpack_require__) {

/*
 * Tine 2.0
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Martin Jatho <m.jatho@metaways.de>
 * @copyright   Copyright (c) 2007-2012 Metaways Infosystems GmbH (http://www.metaways.de)
 *
 * TODO: extend Filemanager.nodeContextMenu
 */
Ext.ns('Tine.MailFiler');

__webpack_require__(362);

Tine.MailFiler.nodeContextMenu = {
    actionMgr: Tine.MailFiler.nodeActionsMgr,

    /**
     * on pause
     * @param {} button
     * @param {} event
     */
    onPause: function (button, event) {

        var grid = this.scope;
        var gridStore = grid.store;
        gridStore.suspendEvents();
        var selectedRows = grid.selectionModel.getSelections();
        for(var i=0; i < selectedRows.length; i++) {
            var fileRecord = selectedRows[i];
            if(fileRecord.fileRecord) {
                fileRecord = fileRecord.fileRecord;
            }
            var upload = Tine.Tinebase.uploadManager.getUpload(fileRecord.get('uploadKey'));
            upload.setPaused(true);
        }
        gridStore.resumeEvents();
        grid.actionUpdater.updateActions(gridStore);
        this.scope.selectionModel.deselectRange(0, this.scope.selectionModel.getCount());
    },


    /**
     * on resume
     * @param {} button
     * @param {} event
     */
    onResume: function (button, event) {

        var grid = this.scope;
        var gridStore = grid.store;
        gridStore.suspendEvents();
        var selectedRows = grid.selectionModel.getSelections();
        for(var i=0; i < selectedRows.length; i++) {
            var fileRecord = selectedRows[i];
            if(fileRecord.fileRecord) {
                fileRecord = fileRecord.fileRecord;
            }
            var upload = Tine.Tinebase.uploadManager.getUpload(fileRecord.get('uploadKey'));
            upload.resumeUpload();
        }
        gridStore.resumeEvents();
        grid.actionUpdater.updateActions(gridStore);
        this.scope.selectionModel.deselectRange(0, this.scope.selectionModel.getCount());

    },

    /**
     * checks whether resume button shuold be enabled or disabled
     *
     * @param action
     * @param grants
     * @param records
     */
    isResumeEnabled: function(action, grants, records) {

        for(var i=0; i<records.length; i++) {

            var record = records[i];
            if(record.fileRecord) {
                record = record.fileRecord;
            }

            if(record.get('type') == 'folder') {
                action.hide();
                return;
            }
        }

        for(var i=0; i < records.length; i++) {

            var record = records[i];
            if(record.fileRecord) {
                record = record.fileRecord;
            }
            if(!record.get('status') || (record.get('type') != 'folder' &&  record.get('status') != 'uploading'
                    &&  record.get('status') != 'paused' && record.get('status') != 'pending')) {
                action.hide();
                return;
            }
        }

        action.show();

        for(var i=0; i < records.length; i++) {

            var record = records[i];
            if(record.fileRecord) {
                record = record.fileRecord;
            }

            if(record.get('status')) {
                action.setDisabled(false);
            }
            else {
                action.setDisabled(true);
            }
            if(record.get('status') && record.get('status') != 'paused') {
                action.setDisabled(true);
            }

        }
    },

    /**
     * checks whether pause button shuold be enabled or disabled
     *
     * @param action
     * @param grants
     * @param records
     */
    isPauseEnabled: function(action, grants, records) {

        for(var i=0; i<records.length; i++) {

            var record = records[i];
            if(record.fileRecord) {
                record = record.fileRecord;
            }

            if(record.get('type') === 'folder') {
                action.hide();
                return;
            }
        }

        for(var i=0; i < records.length; i++) {

            var record = records[i];
            if(record.fileRecord) {
                record = record.fileRecord;
            }

            if(!record.get('status') || (record.get('type ') != 'folder' && record.get('status') != 'paused'
                    &&  record.get('status') != 'uploading' && record.get('status') != 'pending')) {
                action.hide();
                return;
            }
        }

        action.show();

        for(var i=0; i < records.length; i++) {

            var record = records[i];
            if(record.fileRecord) {
                record = record.fileRecord;
            }

            if(record.get('status')) {
                action.setDisabled(false);
            }
            else {
                action.setDisabled(true);
            }
            if(record.get('status') && record.get('status') !=='uploading'){
                action.setDisabled(true);
            }

        }
    }
};

// extends Tine.widgets.tree.ContextMenu
Ext.applyIf(Tine.MailFiler.nodeContextMenu, Tine.widgets.tree.ContextMenu);


/***/ }),

/***/ 781:
/***/ (function(module, exports, __webpack_require__) {

/*
 * Tine 2.0
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2007-2017 Metaways Infosystems GmbH (http://www.metaways.de)
 */
Ext.ns('Tine.MailFiler');

__webpack_require__(362);

/**
 * File grid panel
 * 
 * @namespace   Tine.MailFiler
 * @class       Tine.MailFiler.NodeGridPanel
 * @extends     Tine.Filemanager.NodeGridPanel
 * 
 * <p>Node Grid Panel</p>
 * <p><pre>
 * </pre></p>
 * 
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2007-2017 Metaways Infosystems GmbH (http://www.metaways.de)
 *
 * @param       {Object} config
 * @constructor
 * Create a new Tine.MailFiler.FileGridPanel
 */
Tine.MailFiler.NodeGridPanel = Ext.extend(Tine.Filemanager.NodeGridPanel, {

    recordClass: Tine.MailFiler.Model.Node,

    /**
     * message detail panel
     *
     * @type Tine.MailFiler.GridDetailsPanel
     * @property detailsPanel
     */
    detailsPanel: null,

    /**
     * inits this cmp
     * @private
     */
    initComponent: function() {
        this.initDetailsPanel();
        this.recordProxy = Tine.MailFiler.fileRecordBackend;

        Tine.MailFiler.NodeGridPanel.superclass.initComponent.call(this);
    },

    /**
     * the details panel (shows message content)
     *
     * @private
     */
    initDetailsPanel: function() {
        this.detailsPanel = new Tine.MailFiler.GridDetailsPanel({
            gridpanel: this,
            grid: this,
            app: this.app,
            i18n: this.app.i18n
        });
    },

    /**
     * returns cm
     *
     * @return Ext.grid.ColumnModel
     * @private
     *
     */
    getColumnModel: function(){
        var columns = [{
            id: 'tags',
            header: this.app.i18n._('Tags'),
            dataIndex: 'tags',
            width: 50,
            renderer: Tine.Tinebase.common.tagsRenderer,
            sortable: false,
            hidden: false
        },{
            id: 'name',
            header: this.app.i18n._("Name"),
            width: 70,
            sortable: true,
            dataIndex: 'name',
            renderer: Ext.ux.PercentRendererWithName
        },{
            id: 'flags',
            header: this.app.i18n._("Flags"),
            width: 24,
            sortable: true,
            dataIndex: 'flags',
            renderer: this.flagRenderer
        },{
            id: 'subject',
            header: this.app.i18n._("Subject"),
            width: 300,
            sortable: true,
            dataIndex: 'subject',
            renderer: this.messageRenderer
        },{
            id: 'from_email',
            header: this.app.i18n._("From (Email)"),
            width: 100,
            sortable: true,
            dataIndex: 'from_email',
            renderer: this.messageRenderer
        },{
            id: 'from_name',
            header: this.app.i18n._("From (Name)"),
            width: 100,
            sortable: true,
            dataIndex: 'from_name',
            renderer: this.messageRenderer
        },{
            id: 'sender',
            header: this.app.i18n._("Sender"),
            width: 100,
            sortable: true,
            dataIndex: 'sender',
            hidden: true,
            renderer: this.messageRenderer
        },{
            id: 'to_flat',
            header: this.app.i18n._("To"),
            width: 150,
            sortable: true,
            dataIndex: 'to_flat',
            renderer: this.messageRenderer
        },{
            id: 'sent',
            header: this.app.i18n._("Sent"),
            width: 100,
            sortable: true,
            dataIndex: 'sent',
            hidden: true,
            renderer: this.messageRenderer
        },{
            id: 'received',
            header: this.app.i18n._("Received"),
            width: 100,
            sortable: true,
            dataIndex: 'received',
            renderer: this.messageRenderer
        },{
            id: 'size',
            header: this.app.i18n._("Size"),
            width: 40,
            sortable: true,
            dataIndex: 'size',
            hidden: true,
            renderer: Tine.Tinebase.common.byteRenderer.createDelegate(this, [2, true], 3)
        },{
            id: 'contenttype',
            header: this.app.i18n._("Contenttype"),
            width: 50,
            sortable: true,
            dataIndex: 'contenttype',
            hidden: true,
            renderer: function(value, metadata, record) {

                var app = Tine.Tinebase.appMgr.get('MailFiler');
                if(record.data.type == 'folder') {
                    return app.i18n._("Folder");
                }
                else {
                    return value;
                }
            }
        },{
            id: 'creation_time',
            header: this.app.i18n._("Creation Time"),
            width: 50,
            sortable: true,
            dataIndex: 'creation_time',
            hidden: true,
            renderer: Tine.Tinebase.common.dateTimeRenderer
        },{
            id: 'created_by',
            header: this.app.i18n._("Created By"),
            width: 50,
            sortable: true,
            dataIndex: 'created_by',
            renderer: Tine.Tinebase.common.usernameRenderer
        },{
            id: 'last_modified_time',
            header: this.app.i18n._("Last Modified Time"),
            width: 80,
            sortable: true,
            dataIndex: 'last_modified_time',
            hidden: true,
            renderer: Tine.Tinebase.common.dateTimeRenderer
        },{
            id: 'last_modified_by',
            header: this.app.i18n._("Last Modified By"),
            width: 50,
            sortable: true,
            dataIndex: 'last_modified_by',
            hidden: true,
            renderer: Tine.Tinebase.common.usernameRenderer
        }];

        return new Ext.grid.ColumnModel({
            defaults: {
                sortable: true,
                resizable: true
            },
            columns: columns
        });
    },

    /**
     * get flag icon
     *
     * @param {String} flags
     * @return {String}
     * @private
     *
     * TODO  use spacer if first flag(s) is/are not set?
     */
    flagRenderer: function(value, metadata, record) {
        var icons = [],
            result = '',
            record = record.get('message')
                ? new Tine.Felamimail.Model.Message(record.get('message'), record.get('message').id)
                : null;

        if (! record) {
            return '';
        }

        if (record.hasFlag('\\Answered')) {
            icons.push({src: 'images/oxygen/16x16/actions/mail-reply-sender.png', qtip: Ext.util.Format.htmlEncode(i18n._('Answered'))});
        }
        if (record.hasFlag('Passed')) {
            icons.push({src: 'images/oxygen/16x16/actions/mail-forward.png', qtip: Ext.util.Format.htmlEncode(i18n._('Forwarded'))});
        }
        if (record.hasFlag('Tine20')) {
            icons.push({src: 'images/favicon.png', qtip: Ext.util.Format.htmlEncode(i18n._('Tine20'))});
        }

        Ext.each(icons, function(icon) {
            result += '<img class="FelamimailFlagIcon" src="' + icon.src + '" ext:qtip="' + Tine.Tinebase.common.doubleEncode(icon.qtip) + '">';
        }, this);

        return result;
    },

    /**
     * renders message
     * @param {Integer} value
     * @param {Object} metadata
     * @param {Tine.Tinebase.data.Record} record
     * @param {String} field
     * @return {String}
     *
     * TODO should be generalized
     */
    messageRenderer: function (value, metadata, record) {
        var messageRecord = record ? new Tine.Felamimail.Model.Message(record.get('message'), record.get('message').id) : null,
            field = this.dataIndex,
            result = messageRecord ? messageRecord.get(field) : '';

        if ( field !== '') {
            switch (field) {
                case 'size':
                    result = Ext.util.Format.fileSize(result)
                    break;
                case 'received':
                case 'sent':
                    result = Tine.Tinebase.common.dateTimeRenderer(result);
                    break;
            }
        }
        return result;
    },

    /**
     * init actions with actionToolbar, contextMenu and actionUpdater
     * @private
     *
     * TODO use Filemanager actions if available
     */
    initActions: function() {

        this.initMailActions();

        this.action_createFolder = Tine.MailFiler.nodeActionsMgr.get('createFolder');
        this.action_editFile = Tine.MailFiler.nodeActionsMgr.get('edit');
        this.action_deleteRecord = Tine.MailFiler.nodeActionsMgr.get('delete');
        this.action_download = Tine.MailFiler.nodeActionsMgr.get('download');

        // FIXME: this is broken (see Filemanager)
        //this.action_goUpFolder = new Ext.Action({
        //    allowMultiple: true,
        //    actionType: 'goUpFolder',
        //    text: this.app.i18n._('Folder Up'),
        //    handler: this.onLoadParentFolder,
        //    iconCls: 'action_filemanager_folder_up',
        //    actionUpdater: function(action) {
        //        var _ = window.lodash,
        //            path = _.get(this, 'currentFolderNode.attributes.path', false);
        //
        //        action.setDisabled(path == '/');
        //    }.createDelegate(this),
        //    scope: this
        //});

        this.contextMenu = Tine.MailFiler.GridContextMenu.getMenu({
            nodeName: Tine.MailFiler.Model.Node.getRecordName(),
            actions: ['delete', 'download', 'edit'],
            scope: this,
            backend: 'MailFiler',
            backendModel: 'Node'
        });
        this.contextMenu.addItem(this.action_reply);
        this.contextMenu.addItem(this.action_replyAll);
        this.contextMenu.addItem(this.action_forward);

        this.folderContextMenu = Tine.MailFiler.GridContextMenu.getMenu({
            nodeName: this.app.i18n._(this.app.getMainScreen().getWestPanel().getContainerTreePanel().containerName),
            actions: ['delete', 'rename', 'edit'],
            scope: this,
            backend: 'MailFiler',
            backendModel: 'Node'
        });

        this.actionUpdater.addActions(this.contextMenu.items);
        this.actionUpdater.addActions(this.folderContextMenu.items);

        this.actionUpdater.addActions([
            this.action_reply,
            this.action_replyAll,
            this.action_forward,
            this.action_createFolder,
            //this.action_goUpFolder,
            this.action_download,
            this.action_deleteRecord,
            this.action_editFile,
            this.action_printmessage
       ]);
    },

    /**
     * init mail actions
     *
     * @private
     *
     * TODO use action manager
     */
    initMailActions: function() {

        var fMailApp = Tine.Tinebase.appMgr.get('Felamimail');

        this.action_reply = new Ext.Action({
            requiredGrant: 'readGrant',
            actionType: 'reply',
            text: this.app.i18n._('Reply'),
            handler: this.onMessageReplyTo.createDelegate(this, [false]),
            iconCls: 'action_email_reply',
            actionUpdater: this.updateMessageAction,
            disabled: true
        });

        this.action_replyAll = new Ext.Action({
            requiredGrant: 'readGrant',
            actionType: 'replyAll',
            text: this.app.i18n._('Reply To All'),
            handler: this.onMessageReplyTo.createDelegate(this, [true]),
            iconCls: 'action_email_replyAll',
            actionUpdater: this.updateMessageAction,
            disabled: true
        });

        this.action_forward = new Ext.Action({
            requiredGrant: 'readGrant',
            actionType: 'forward',
            text: this.app.i18n._('Forward'),
            handler: this.onMessageForward.createDelegate(this),
            iconCls: 'action_email_forward',
            actionUpdater: this.updateMessageAction,
            disabled: true
        });

        this.action_printmessage = new Ext.Action({
            requiredGrant: 'readGrant',
            text: this.app.i18n._('Print Message'),
            handler: this.onPrint.createDelegate(this, []),
            disabled: true,
            iconCls:'action_print',
            actionUpdater: this.updateMessageAction,
            scope:this
        });
    },


    /**
     * Ripped off felamimail
     *
     * @param detailsPanel
     */
    onPrint: function(detailsPanel) {
        var id = Ext.id(),
            doc = document,
            frame = doc.createElement('iframe');

        Ext.fly(frame).set({
            id: id,
            name: id,
            style: {
                position: 'absolute',
                width: '210mm',
                height: '297mm',
                top: '-10000px',
                left: '-10000px'
            }
        });

        doc.body.appendChild(frame);

        Ext.fly(frame).set({
            src : Ext.SSL_SECURE_URL
        });

        var doc = frame.contentWindow.document || frame.contentDocument || WINDOW.frames[id].document,
            content = this.getDetailsPanelContentForPrinting(detailsPanel || this.detailsPanel);

        doc.open();
        doc.write(content);
        doc.close();

        frame.contentWindow.focus();
        frame.contentWindow.print();
    },

    /**
     * get detail panel content
     *
     * @param {Tine.Felamimail.GridDetailsPanel} details panel
     * @return {String}
     */
    getDetailsPanelContentForPrinting: function(detailsPanel) {
        // TODO somehow we have two <div class="preview-panel-felamimail"> -> we need to fix that and get the first element found
        var detailsPanels = detailsPanel.getEl().query('.preview-panel-felamimail');

        var detailsPanelContent = (detailsPanels.length > 1) ? detailsPanels[1].innerHTML : detailsPanels[0].innerHTML;

        var buffer = '<html><head>';
        buffer += '<title>' + this.app.i18n._('Print Preview') + '</title>';
        buffer += '</head><body>';
        buffer += detailsPanelContent;
        buffer += '</body></html>';

        return buffer;
    },

    onMessageReplyTo: function(toAll) {
        var sm = this.getGrid().getSelectionModel(),
            node = sm.getSelected();
            msg = node.get('message'),
            msgBody = Ext.util.Format.nl2br(msg.body);

        msgBody = '<br/>'
            + '<blockquote class="felamimail-body-blockquote">' + msgBody + '</blockquote><br/>';

        var date = msg.sent
            ? msg.sent
            : (msg.received) ? msg.received : new Date();

        var quote = String.format(this.app.i18n._('On {0}, {1} wrote'),
                Tine.Tinebase.common.dateTimeRenderer(date),
                Ext.util.Format.htmlEncode(msg.from_name)
            ) + ':';

        // pass all relevant params (body, subject, ...) to prevent mail loading in Felamimail
        var win = Tine.Felamimail.MessageEditDialog.openWindow({
            //record: msg,
            replyTo : Ext.encode(msg),
            replyToAll: toAll,
            msgBody: quote + msgBody
        });
    },

    onMessageForward: function() {
        var sm = this.getGrid().getSelectionModel(),
            node = sm.getSelected();
            msg = node.get('message'),
            msgBody = Ext.util.Format.nl2br(msg.body),
            quote = String.format('{0}-----' + this.app.i18n._('Original message') + '-----{1}',
                '<br /><b>',
                '</b><br />'),
            attachments = msg.attachments;

        Ext.each(attachments, function(attachment) {
            // set name and MailFiler path for fetching attachment from filesystem when sending
            attachment.name = attachment.filename;
            attachment.type = 'filenode';
            attachment.id = 'MailFiler'  + '|' + node.get('path') + '|' + msg.messageuid  + '|' + attachment.partId
        }, this);

        // pass all relevant params (body, subject, ...) to prevent mail loading in Felamimail
        var win = Tine.Felamimail.MessageEditDialog.openWindow({
            forwardMsgs : Ext.encode([msg]),
            attachments: attachments,
            msgBody: quote + msgBody
        });
    },

    /**
     * check file type for message actions
     *
     * @param action
     * @param grants
     * @param records
     * @returns {boolean}
     */
    updateMessageAction: function(action, grants, records) {
        var isFile = false;
        Ext.each(records, function (record) {
            if (record.get('type') == 'file') {
                isFile = true;
                return true;
            }
        });

        var disable = records.length > 1 || ! isFile;
        action.setDisabled(disable);
        return false;
    },

    /**
     * grid row doubleclick handler
     *
     * @param {Tine.MailFiler.NodeGridPanel} grid
     * @param {} row record
     * @param {Ext.EventObjet} e
     */
    onRowDblClick: function (grid, row, e) {
        var rowRecord = grid.getStore().getAt(row);

        if (rowRecord.data.type == 'file') {
            Tine.MailFiler.NodeEditDialog.openWindow({
                record: rowRecord
            });
        } else if (rowRecord.data.type == 'folder') {
            this.expandFolder(rowRecord);
        }
    },

    /**
     * get action toolbar
     *
     * @return {Ext.Toolbar}
     */
    getActionToolbar: function() {
        if (! this.actionToolbar) {
            this.actionToolbar = new Ext.Toolbar({
                defaults: {height: 55},
                items: [{
                    xtype: 'buttongroup',
                    layout: 'toolbar',
                    buttonAlign: 'left',
                    columns: 9,
                    defaults: {minWidth: 60},
                    items: [
                        Ext.apply(new Ext.Button(this.action_write), {
                            scale: 'medium',
                            rowspan: 2,
                            iconAlign: 'top'
                        }),
                        Ext.apply(new Ext.Button(this.action_reply), {
                            scale: 'medium',
                            rowspan: 2,
                            iconAlign: 'top'
                        }),
                        Ext.apply(new Ext.Button(this.action_replyAll), {
                            scale: 'medium',
                            rowspan: 2,
                            iconAlign: 'top'
                        }),
                        Ext.apply(new Ext.Button(this.action_forward), {
                            scale: 'medium',
                            rowspan: 2,
                            iconAlign: 'top'
                        }),
                        Ext.apply(new Ext.Button(this.action_printmessage), {
                            scale: 'medium',
                            rowspan: 2,
                            iconAlign: 'top'
                        }),
                        Ext.apply(new Ext.Button(this.action_editFile), {
                            scale: 'medium',
                            rowspan: 2,
                            iconAlign: 'top'
                        }),
                        Ext.apply(new Ext.Button(this.action_deleteRecord), {
                            scale: 'medium',
                            rowspan: 2,
                            iconAlign: 'top'
                        }),
                        Ext.apply(new Ext.Button(this.action_createFolder), {
                            scale: 'medium',
                            rowspan: 2,
                            iconAlign: 'top'
                        }),
                        //Ext.apply(new Ext.Button(this.action_goUpFolder), {
                        //    scale: 'medium',
                        //    rowspan: 2,
                        //    iconAlign: 'top'
                        //}),
                        Ext.apply(new Ext.Button(this.action_download), {
                            scale: 'medium',
                            rowspan: 2,
                            iconAlign: 'top'
                        })
                 ]
                }, this.getActionToolbarItems()]
            });


            if (this.filterToolbar && typeof this.filterToolbar.getQuickFilterField == 'function') {
                this.actionToolbar.add('->', this.filterToolbar.getQuickFilterField());
            }
        }

        this.actionToolbar.on('resize', this.onActionToolbarResize, this, {buffer: 250});
        this.actionToolbar.on('show', this.onActionToolbarResize, this);

        return this.actionToolbar;
    }
});


/***/ }),

/***/ 782:
/***/ (function(module, exports) {

/*
 * Tine 2.0
 *
 * @package     Tinebase
 * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3
 * @author      Philipp Schüle <p.schuele@metaways.de>
 * @copyright   Copyright (c) 2010-2015 Metaways Infosystems GmbH (http://www.metaways.de)
 */

Ext.ns('Tine.MailFiler');

/**
 * @namespace Tine.MailFiler
 * @class Tine.MailFiler.Application
 * @extends Tine.Tinebase.Application
 */
Tine.MailFiler.Application = Ext.extend(Tine.Tinebase.Application, {
    /**
     * Get translated application title of this application
     *
     * @return {String}
     */
    getTitle : function() {
        return this.i18n.gettext('MailFiler');
    }
});

/*
 * register additional action for genericpickergridpanel
 */
Tine.widgets.relation.MenuItemManager.register('MailFiler', 'Node', {
    text: 'Save locally',   // i18n._('Save locally')
    iconCls: 'action_filemanager_save_all',
    requiredGrant: 'readGrant',
    actionType: 'download',
    allowMultiple: false,
    handler: function(action) {
        var node = action.grid.store.getAt(action.gridIndex).get('related_record');
        var downloadPath = node.path;
        var downloader = new Ext.ux.file.Download({
            params: {
                method: 'MailFiler.downloadFile',
                requestType: 'HTTP',
                id: '',
                path: downloadPath
            }
        }).start();
    }
});

/**
 * @namespace Tine.MailFiler
 * @class Tine.MailFiler.MainScreen
 * @extends Tine.widgets.MainScreen
 */
Tine.MailFiler.MainScreen = Ext.extend(Tine.widgets.MainScreen, {
    activeContentType: 'Node'
});


/***/ }),

/***/ 783:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(784);
if(typeof content === 'string') content = [[module.i, content, '']];
// Prepare cssTransformation
var transform;

var options = {"hmr":true}
options.transform = transform
// add the styles to the DOM
var update = __webpack_require__(68)(content, options);
if(content.locals) module.exports = content.locals;
// Hot Module Replacement
if(false) {
	// When the styles change, update the <style> tags
	if(!content.locals) {
		module.hot.accept("!!../../Tinebase/js/node_modules/css-loader/index.js!./MailFiler.css", function() {
			var newContent = require("!!../../Tinebase/js/node_modules/css-loader/index.js!./MailFiler.css");
			if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
			update(newContent);
		});
	}
	// When the module is disposed, remove the <style> tags
	module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 784:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(20)(undefined);
// imports


// module
exports.push([module.i, "/**\n * Tine 2.0\n * \n * @package     MailFiler\n * @license     http://www.gnu.org/licenses/agpl.html AGPL Version 3\n * @author      Martin Jatho <m.jatho@metaways.de>\n * @copyright   Copyright (c) 2007-2011 Metaways Infosystems GmbH (http://www.metaways.de)\n * @version     $Id: Tasks.css 3797 2008-08-11 08:33:21Z c.weiss@metaways.de $\n *\n */\n\n.MailFilerIconCls, .tine-recordclass-gridicon.MailFilerNode {\n    background-image:url(" + __webpack_require__(785) + ") !important;\n}\n\n/* mail preview @todo make it more general and move to tinebase for use in felamimail */\n.preview-panel-mail {\n    padding: 5px;\n}\n\n.preview-panel-mail-body {\n    margin-top: 5px;\n}\n\n.mail-message-body-html,\n.preview-panel-mail-body {\n    font-size: 13px;\n    background-color: #fff;\n    padding: 5px;\n}\n\n.preview-panel-mail-body ul {\n    list-style: circle outside;\n    margin-left: 20px;\n}\n.preview-panel-mail-body ol {\n    list-style: decimal outside;\n    margin-left: 20px;\n}\n\n.preview-panel-mail-body strong {\n    font-weight: bold;\n    font-style: inherit;\n}\n\n.preview-panel-mail-body em {\n    font-style: italic;\n    font-weight: inherit;\n}\n\n.preview-panel-mail-body .x-form-textarea {\n    margin-top: 5px;\n    font: normal 13px courier;\n    border: 0;\n}\n\n.mail-edit-text-plain .x-form-textarea {\n    font-size: 13px;\n    padding-top: 5px;\n    padding-left: 5px;\n}", ""]);

// exports


/***/ }),

/***/ 785:
/***/ (function(module, exports) {

module.exports = "\"data:image/svg+xml,%3C?xml version='1.0' encoding='utf-8'?%3E %3C!-- Generator: Adobe Illustrator 21.1.0, SVG Export Plug-In . SVG Version: 6.00 Build 0) --%3E %3Csvg version='1.1' id='Ebene_1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' viewBox='0 0 42.5 42.5' style='enable-background:new 0 0 42.5 42.5;' xml:space='preserve'%3E %3Cpath id='Icon_FileManager' d='M41.7,23c0-0.6-0.4-0.9-1.3-0.9H13.6c-0.7,0-1.4,0.2-2.1,0.5c-0.7,0.4-1.3,0.8-1.8,1.3l-7.2,8.9 c-0.3,0.4-0.4,0.7-0.4,1c0,0.6,0.4,0.9,1.3,0.9h26.8c0.7,0,1.4-0.2,2.1-0.5c0.8-0.4,1.3-0.8,1.7-1.3l7.2-8.9 C41.5,23.6,41.7,23.3,41.7,23z M13.6,19.6h18.9v-3.9c0-0.7-0.2-1.2-0.7-1.7s-1-0.7-1.7-0.7H16c-0.7,0-1.2-0.2-1.7-0.7 s-0.7-1-0.7-1.7V9.4c0-0.7-0.2-1.2-0.7-1.7S11.9,7,11.2,7H3.4C2.7,7,2.1,7.2,1.7,7.7S1,8.7,1,9.4v21l6.3-7.8C8,21.7,9,21,10.2,20.4 S12.5,19.6,13.6,19.6z'/%3E %3C/svg%3E\""

/***/ })

});